
(** User Mathematica initialization file **)

(** Decide how to display graphics on this machine **)

Begin["System`Private`"]
(* Hide any symbols which are created *)

Which[
        $Remote || $ParentLink =!= Null,               <<"PSDirect.m",
        Environment["DISPLAY"] =!= $Failed,            <<"Motif.m",
        True,                                          <<"Terminal.m"
     ]



Print["Set up global variable $HistoryLength = 15"]; Print[""];
$HistoryLength = 15;

Print["Loading  Controlsystems`Master` ..."]; Print[""];
<<Controlsystems`

Print["Loading  NumericalControlMethods` ..."]; Print[""];
<< NumericalControlMethods`

Print["Loading  Developer` ..."]; Print[""];
<<Developer`

Print["Loading  Experimental` ..."]; Print[""];
<<Experimental`



(** query *********************************************************************)
If[
   MatchQ[ InputString["Load Polynomial package? Y/N (default=yes):"],
            "y" | "Y" | "yes" | "Yes" | "YES" | ""
   ],

   (* load polynomial package*)
      Print["Loading  Polynomial`Master` ..."]; Print[""];
      <<Polynomial`;
      
      Global`$Format = "Nice";
      Global`$Verbose = True;
      

   (* Open palette for $Format (PolyGlobal[]) *)
      Print["Open palette for $Format (PolyGlobal[])"]; Print[""];
      NotebookOpen["P:\\Wolfram Research\\Mathematica\\4.2\\AddOns\\ExtraPackages\\Polynomial\\FrontEnd\\Palettes\\Format.nb"]
      ,
   (**************************)
   Print["Polynomial package was not loaded."]; Print[""];
];
(** end query *****************************************************************)


(* Exit button *)
Print["Open palette for Exit[]"];Print[""];
NotebookOpen["P:\\Wolfram Research\\Mathematica\\4.2\\AddOns\\ExtraPackages\\Utilities\\Exit.nb"];

Print["End Init."]; Print[""];

End[]