BeginPackage["Polynomial`Dot`","Polynomial`Object`","Polynomial`Global`","Polynomial`Common`"]
(* U S A G E *)
(* O P T I O N S *)
(* M E S S A G E *) 
   
Begin["`Private`"]

(* Developer context *)
<<Developer`

dimensions[sym_Symbol] := {-2, -1};
dimensions[pol_PolyMat] := Size[pol];


MakeDotsIdx[pols_(*List*)] := 
Module[{idx = {{1}}, last = 1, sizes = dimensions /@ pols},
   Do[
      If[sizes[[i, 2]] === sizes[[i + 1, 1]],
        idx[[last]] = Join[idx[[last]], {i + 1}],
        AppendTo[idx, {i + 1}];
        last = last + 1;
      ]
      , {i, 1, Length[sizes] - 1}
   ];
   
   idx
];

Unprotect[Dot];

   (* polymat + polymat + ... *)
                                                            
Dot[pols:(__PolyMat|___Symbol)...] /; Not[MatchQ[Dimensions[idxdots = MakeDotsIdx[{pols}]],{_Integer,1}]] :=
With[{idx = idxdots},
   Clear[idxdots];
   Dot @@ (DotGoodSize[{pols}[[#]]] & /@ idx)
];          

Dot[x_Poly,y_Poly] := Times[x,y];

(* scalar DESolve *)
(*
Dot[x_Poly,y_PolyMat] /; Size[y]==={1,1} := Times[x,Poly[Flatten[y[[1]]], y[[2]], Deg[y]]];
Dot[x_PolyMat,y_Poly] /; Size[x]==={1,1} := Times[Poly[Flatten[x[[1]]], x[[2]], Deg[x]],y];
*)

Protect[Dot]; 

(* pol . pol *)   
DotGoodSize[{A_PolyMat}] := A;
   
DotGoodSize[{A_PolyMat,B_PolyMat,X__PolyMat}] := DotGoodSize[{DotGoodSize[{A,B}],X}]; (* !! ?poradi jak nasobit *)

DotGoodSize[{A_PolyMat,B_PolyMat}] :=
With[{ degA = A[[3]], degB = B[[3]] , rA = Size[A][[1]]},
   PolyMat[Partition[Dot[SylvestrMatrix[A,degB+1],SylvestrMatrix[B,1]], rA], A[[2]], degA+degB]
];   

(* sym . sym *)
DotGoodSize[{syms___Symbol}] := Dot[syms];

(* !! dodelat zeroing *)

(*******************************************************************************
   VZOR fce. PLUS
*******************************************************************************)

End[]
 
EndPackage[]