(* :Title:
   Master Declarations File for Polynomial
*)

(* :Summary:
   This file contains declarations of all the major symbols
   contained in files in this directory.  When loaded, it sets
   up the symbols with attribute Stub, so the correct package
   will be loaded when the symbol is called.
*)

(* :Author: Petr Kujan
*)

(* :History:
   File created on 21 April 2003
*)

BeginPackage["Polynomial`"]
EndPackage[]

(* Declarations for package Polynomial`Object` *)
DeclarePackage["Polynomial`Object`",{
                  "P","PC","PM","PMC","PLC",
                  "Poly","PolyMat"
              }]
                        
(* Declarations for package Polynomial`PMRandom` *)
DeclarePackage["Polynomial`Common`",{"PolyQ","IsPoly","ListPoly",
                           "Deg","SquareQ",(*"NumericQ",*)
                           "SylvestrMatrix",
                           "DropLastZeros",
                           "DropLastZerosPolMat",
                           "Star",
                           "PrintVerbose",
                           "Pol",
                           "NonZeroMin","SymbolQ",
                           "Size",
                           "CoefficientListZeroingLast",
                           "Variable"
                           }]
                           
(* Declarations for package Polynomial`SPF` *)
DeclarePackage["Polynomial`SPF`",{"SPF"}]                           

(* Declarations for package Polynomial`AXXABSolve` *)
DeclarePackage["Polynomial`AXXABSolve`",{"AXXABSolve"}]

(* Declarations for package Polynomial`DESolve` *)
DeclarePackage["Polynomial`DESolve`",{"DESolve","AXBSolve"}]

(* Declarations for package Polynomial`PMRandom` *)
DeclarePackage["Polynomial`Random`",{"PMRandom","PRandom"}]

(* Declarations for package Polynomial`PlotStability` *)
DeclarePackage["Polynomial`PlotStability`",{"RouthTable","DRouthTable","JutyTable",
                                            "StabilityPlot","StabilityPlot3D","TStabilityPlot"
                                          }]

(* Declarations for package Polynomial`StatePortrait` *)
DeclarePackage["Polynomial`StatePortrait`",{"StatePortrait","VectorData","GeneralSolution",
                                            "VectorFieldPlot","EigenVectorsPlot","EigenVectorsLinePlot",
                                            "TrajectoryPlot","BoundaryConditionPlot"
                                          }]

(* Declarations for package Polynomial`StatePortraitNL` *)
DeclarePackage["Polynomial`StatePortraitNL`",{"StatePortraitNL","StateDescription","StatePortraitPlot",
                                            "StatePortraitVector"
                                          }]


(* Declarations for package Polynomial`Plus` *)
(*DeclarePackage["Polynomial`Plus`",{"Plus"}]*)
<<Polynomial`Plus`

(* Declarations for package Polynomial`Times` *)
<<Polynomial`Times`

(* Declarations for package Polynomial`Dot` *)
<<Polynomial`Dot`

(* Declarations for package Polynomial`Det` *)
<<Polynomial`Det`


(*<<Polynomial`Plus`*)

(* Redefine standard function for poly *)
<<Polynomial`Redefine`

(* Load global variable *)
<<Polynomial`Global`

(* Declarations for package Polynomial`StabilityPlot` *)
DeclarePackage["Polynomial`PlotStability`",{"RouthTable","DRouthTable",
                                             "JuryTable",
                                             "StabilityPlot",
                                             "TStabilityPlot",
                                             "StabilityPlot3D"}]
                                                 
(*******************************************************************************
(* Declarations for package Polynomial`AXBYCSolve` *)
DeclarePackage["Polynomial`AXBYCSolve`",{"AXBSolve","AXBYCSolve","PolyExtendedGCD"}]

(* Declarations for package Polynomial`Det` *)
DeclarePackage["Polynomial`Det`",{"detpm"}]

(* Declarations for package Polynomial`Dot` *)
DeclarePackage["Polynomial`Dot`",{"dotpmc"}]
*******************************************************************************)
(* End of Master package *)

Null