BeginPackage["Polynomial`Plus`","Polynomial`Object`","Polynomial`Global`","Polynomial`Common`"]

(* U S A G E *)
(* O P T I O N S *)
(* M E S S A G E *) 
   General::difvar = " Different variable! ";
   General::plusdim = " Matrices not of the same dimensions. ";
   Plus::errvar = " Error variable. ";

Begin["`Private`"]

(* Developer context *)
<<Developer`

Unprotect /@ {Poly,PolyMat};
   (* polymat + polymat + ... *)

PolyMat /: Plus[A:PolyMat[pmcA_,varA_,degA_], B:PolyMat[pmcB_,varB_,degB_]] :=
   Block[{sol, var, deg},
      If[Size[A] =!= Size[B],
      (* then *)
         Message[General::plusdim]; Null,
      (* else *)
         me = NonZeroMin[Abs[{pmcA,pmcB}]]; (* !! pomale *)
         If[Head[me] === Min, If[NumericQ[me[[1]]], me = me[[1]], me = 0]]; (* for parametrs in pm *)
   
         If[varA=!=varB, Message[General::difvar]; var = Global`$Variable, var = varA];
         If[degA === degB,
         (* then *)
            sol = pmcA + pmcB; deg = degA,
         (* else *)
            If[degA > degB,
               sol = pmcA;
               sol[[Range[1,degB+1]]] = sol[[Range[1,degB+1]]]+pmcB; deg = degA,
               sol = pmcB;
               sol[[Range[1,degA+1]]] = sol[[Range[1,degA+1]]]+pmcA; deg = degB
            ]
         ];

         (* zeroing *)
         sol = ToPackedArray[
                  DropLastZerosPolMat[Chop[sol,N[Global`$Zeroing*me]]]
               ];
   
         If[sol =!= {},
            PolyMat[sol, var, Length[sol]-1],
            PolyMat[{Array[0&,Dimensions[A][[{2,3}]]]}, var, -Infinity]
         ]
      ]
   ];

PolyMat /: Plus[A:PolyMat[pmcA_,varA_,degA_], k:Null] := Null;

   (* polymat + konst ... *)
PolyMat /: Plus[A:PolyMat[pmcA_,varA_,degA_], k:__?( Not[PolyQ[#]] && (NumericQ[#] || SymbolQ[#])&)] :=
   If[degA === 0,
      PolyMat[pmcA+k, varA, degA],
      PolyMat[{pmcA[[1]]+k, Sequence @@ pmcA[[Range[2,degA+1]]]},varA,degA]  (* !! uprava 1. matice ? (predpripravit nulovou??)*)
   ];

   (* polymat + poly ... *)
PolyMat /: Plus[A:PolyMat[pmcA_,varA_,degA_], a:Poly[pca_,vara_,dega_]] :=
   Block[{var, sol},
      {r,c} = Dimensions[pmcA[[1]]];
      
      me = NonZeroMin[Abs[{pmcA,pmcB}]]; (* !! pomale *)
      If[Head[me] === Min, If[NumericQ[me[[1]]], me = me[[1]], me = 0]]; (* for parametrs in pm *)


      If[varA =!= vara,Message[General::difvar]; var = Global`$Variable, var = varA];
      If[degA === dega,
         sol = pmcA+pca,
         If[degA > dega,
            sol = {Sequence@@(pmcA[[Range[1,dega+1]]]+pca),Sequence @@ pmcA[[Range[dega+2,degA+1]]]},
            sol = {Sequence@@(pca[[Range[1,degA+1]]]+pmcA),Sequence @@ (Table[#,{r},{c}]& /@ pca[[Range[degA+2,dega+1]]])}
         ]
      ];
         (* zeroing *)
         sol = ToPackedArray[
                 DropLastZerosPolMat[Chop[sol,N[Global`$Zeroing*me]]]
               ];
         PolyMat[sol, var, Length[sol]-1]  
   ];



   (* SCALAR CASE *)

   (* Poly + Poly *)   
Poly /: System`Plus[A:Poly[pcA_,varA_,degA_], B:Poly[pcB_,varB_,degB_]] := 
   Block[{me, sol, var, deg},

      me = NonZeroMin[Abs[{pcA,pcB}]]; (* !! pomale *)
      If[Head[me] === Min, If[NumericQ[me[[1]]], me = me[[1]], me = 0]]; (* for parametrs in pm *)

      
      If[varA=!=varB,Message[General::difvar]; var = Global`$Variable, var = varA];
      If[degA === degB,
      (* then *)
         sol = pcA + pcB; deg = degA,
      (* else *)
         If[degA > degB,
            sol = pcA+PadRight[pcB,degA+1]; deg = degA,
            sol = pcB+PadRight[pcA,degB+1]; deg = degB
         ]
      ];

      (* zeroing *)
      sol = ToPackedArray[
              DropLastZeros[Chop[sol,N[Global`$Zeroing*me]]]
            ];
      If[sol =!= {},
         Poly[sol, var, Length[sol]-1],
         Poly[{0}, var, -Infinity]
      ]
   ];

   (* polynom + Poly *)
(*
Poly /: System`Plus[p:_, pol:Poly[pc_,var_,deg_]]/;PolynomialQ[p,var] :=
   Plus[P[p,var],pol];
*)

   (* const + Poly *)
Poly /: System`Plus[k:_?(NumericQ[#] && Not[PolyQ[#]]&), pol:Poly[pc_,var_,deg_]] :=
   Module[{sol = pc},
      sol[[1]] = sol[[1]]+k; Poly[ToPackedArray[sol],var,deg]
   ];
   
Poly /: System`Plus[sym:_?(SymbolQ[#] && Not[PolyQ[#]]&), pol:Poly[pc_,var_,deg_]] :=
   Module[{sol = pc}, 
      If[ sym === var,
         Message[Plus::errvar]; Null,
         sol[[1]] = sol[[1]]+sym; Poly[sol,var,deg]
      ]
   ];

Unprotect /@ {Poly,PolyMat};

End[]
 
EndPackage[]