(******************************************************************************)
(*          R E D E F I N E   standard function for poly                      *)
(******************************************************************************)

<<Developer` (* !! plati v globalnim kontextu; jednotlive funkce prepsat do samostatnych souboru s kontextem Polynomial` *)


(* M E S S A G E *)
    General::difvar = " Different variable! ";
    General::plusdim = " Matrices not of the same dimensions. ";


(*        U S E F U L    F U N C T I O N S    *)
SymbolQ[expr_]:=AtomQ@Unevaluated[expr]&&Head@Unevaluated[expr]===Symbol;
NonZeros[li_List] := Select[li, (NumericQ[#] && Not[ZeroQ[#]])&];

<<Polynomial`Common`;


(*  PMTest  *)
Unprotect[PolynomialQ];
   PolynomialQ[Null, _] := False;
Protect[PolynomialQ];

(************************************************************)
(*          CoefficientList[pol]                            *)
(************************************************************)
(* SCALAR CASE *)
Unprotect[CoefficientList];
   CoefficientList[pol:PolyMat[pmc_,var_,deg_]] := pmc;
(* SCALAR CASE *)
(*   CoefficientList[pol:Poly[pc_,varp_,deg_],var_] := If[varp===var,pc,Message[General::difvar];pc]; *)
   CoefficientList[pol:Poly[pc_,var_,deg_]] := pc;
Protect[CoefficientList];   


(************************************************************)
(*          NumericQ[pol]                                   *)
(************************************************************)
Unprotect/@{Poly,PolyMat};
   PolyMat /: NumericQ[pol:PolyMat[pmc_,var_,deg_]] /; (And @@ Flatten[Map[NumericQ,pmc,{3}]]) := True;
(* SCALAR CASE *)
   Poly /: NumericQ[pol:Poly[pc_,var_,deg_]] /; (And @@ (NumericQ /@ pc)) := True;
Protect/@{Poly,PolyMat};   

(************************************************************)
(*          Dimensions[pol]                                 *)
(************************************************************)
Unprotect[Dimensions];
   Dimensions[pm:_PolyMat] := Dimensions[pm[[1]]];
   Dimensions[p:Poly[pc_,var_,deg_]] := {deg+1,1,1};
Protect[Dimensions];   

(************************************************************)
(*          SetPrecision[pol]                               *)
(************************************************************)
Unprotect[SetPrecision];
   SetPrecision[pol:PolyMat[pmc_,var_,deg_],precision_Integer?Positive] := 
      PolyMat[SetPrecision[pmc,precision],var,deg];
(* SCALAR CASE *)
   SetPrecision[pol:Poly[pc_,var_,deg_],precision_Integer?Positive] := 
      Poly[SetPrecision[pc,precision],var,deg];
Protect[SetPrecision];

(************************************************************)
(*          N[pol]                                          *)
(************************************************************)
(* !! nefunguje *)
Unprotect /@ {Poly,PolyMat};
   PolyMat /: N[pol:PolyMat[pmc_,var_,deg_],n_Integer:$MinPrecision] := 
      PolyMat[N[pmc,n],var,deg];
(* SCALAR CASE *)
   Poly /: N[pol:Poly[pc_,var_,deg_],n_Integer:$MinPrecision] := 
      Poly[N[pc,n],var,deg];

Protect /@ {Poly,PolyMat};
(************************************************************)
(*              PackedArray                                 *)
(************************************************************)
Unprotect[ToPackedArray];
   Developer`ToPackedArray[pol:PolyMat[pmc_,var_,deg_]] := PolyMat[Developer`ToPackedArray[pmc],var,deg];
(* SCALAR CASE *)
   Developer`ToPackedArray[pol:Poly[pc_,var_,deg_]] := Poly[Developer`ToPackedArray[pc],var,deg];
Protect[ToPackedArray];
Unprotect[FromPackedArray];
   Developer`FromPackedArray[pol:PolyMat[pmc_,var_,deg_]] := PolyMat[Developer`FromPackedArray[pmc],var,deg];
(* SCALAR CASE *)
   Developer`FromPackedArray[pol:Poly[pc_,var_,deg_]] := Poly[Developer`FromPackedArray[pc],var,deg];
Protect[FromPackedArray];
Unprotect[PackedArrayQ];
   Developer`PackedArrayQ[pol:PolyMat[pmc_,var_,deg_]] := Developer`PackedArrayQ[pmc];
(* SCALAR CASE *)
   Developer`PackedArrayQ[pol:Poly[pc_,var_,deg_]] := Developer`PackedArrayQ[pc];
Protect[PackedArrayQ];


(************************************************************)
(*                     N[pol]                               *)
(************************************************************)
(* SCALAR CASE *)
(* !! ERROR - N Protect.nb *)
(*
   N[pol:Poly[pc_,var_,deg_]] ^:= Poly[N[pc],var,deg];
   N[pol:Poly[pc_,var_,deg_],precision_Integer?Positive] ^:= Poly[N[pc,precision],var,deg];
*)