BeginPackage["Polynomial`Times`","Polynomial`Object`","Polynomial`Global`","Polynomial`Common`"]
(* U S A G E *)
(* O P T I O N S *)
(* M E S S A G E *) 
   General::difvar = " Different variable! ";
   General::plusdim = " Matrices not of the same dimensions. ";
   Times::errvar = " Error variable. ";

Begin["`Private`"]

(* Developer context *)
<<Developer`

Unprotect /@ {Poly,PolyMat};

   (* POLYNOMIAL MATRIX *)
PolyMat /: System`Times[k:_?(NumericQ[#] && Not[PolyQ[#]]&), A:PolyMat[pmc_,var_,deg_]] := 
  ( 
   PolyMat[k*pmc,var,deg]
   );

PolyMat /: System`Times[sym:_?(SymbolQ[#] && Not[PolyQ[#]]&), A:PolyMat[pmc_,var_,deg_]] := 
   If[ sym === var,
      Message[Times::errvar]; Null,
      PolyMat[sym*pmc,var,deg]
   ];

   
   (* SCALAR CASE *)
   (* poly * poly *)
Poly /: System`Times[A:Poly[pcA_,varA_,degA_], B:Poly[pcB_,varB_,degB_]] :=
   Module[{me = Min[Min[Abs[NonZeros[pcA]]],Min[Abs[NonZeros[pcB]]]],
         sol, var, deg},
         If[varA=!=varB, Message[General::difvar]; var = Global`$Variable, var = varA];
         (* !! SylvestrMethod x ?prevest na polynomy a vynasobit *)   (* pomaly pro int a real, rychly pro symbol -> SilvestrMatrix[] *)  
         sol = Transpose[SylvestrMatrix[A,degB+1].Transpose[{pcB}]][[1]];         
         (* zeroing *)
         sol = ToPackedArray[
                  DropLastZeros[Chop[sol,N[Global`$Zeroing*me]]]
               ];
         Poly[sol, var, degA+degB]
   ];     

   (* const * poly *)
Poly /: System`Times[k:_?(NumericQ[#] && Not[PolyQ[#]]&), A:Poly[pc_,var_,deg_]] :=
   Poly[k*pc,var,deg];

Poly /: System`Times[sym:_?(SymbolQ[#] && Not[PolyQ[#]]&), A:Poly[pc_,var_,deg_]] :=
   If[ sym === var,
      Message[Times::errvar]; Null,
      Poly[sym*pc,var,deg]
   ];
   
Unprotect /@ {Poly,PolyMat};
  
 
 
End[]
 
EndPackage[]