(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     57606,        917]*)
(*NotebookOutlinePosition[     59174,        967]*)
(*  CellTagsIndexPosition[     59041,        959]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[TextData[Cell[BoxData[GridBox[{
        {
          ButtonBox[
            StyleBox["\[FirstPage]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageFirst"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"First Slide"], 
          ButtonBox[
            StyleBox["\[LeftPointer]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPagePrevious"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Previous Slide"], 
          ButtonBox[
            StyleBox["\[RightPointer]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageNext"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Next Slide"], 
          ButtonBox[
            StyleBox["\[LastPage]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageLast"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Last Slide"], " ", 
          ButtonBox[
            StyleBox[
              RowBox[{
                CounterBox["SlideShowNavigationBar"], \(\(\ \)\(of\)\(\ \)\), 
                
                
                CounterBox["SlideShowNavigationBar", {None, 
                  "SlideShowHeader", -1}]}],
              "SR"],
            ButtonFrame->"None"]}
        }]]]], "SlideShowNavigationBar",
  CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell["Advanced Numerical Methods", "Section",
  TextAlignment->Left,
  TextJustification->0],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006<0000MA000`40O003h00OogooSGoo003oOon=
Ool00?mooheoo`00ogooSGoo003oOon=Ool00?mooheoo`00ogooSGoo003oOon=Ool00?mooheoo`00
ogooSGoo003oOon=Ool00?mooheoo`00>7oo00AS648@BU9S60Aoo`04HaQBU5:DMkd3Ool2Li`4Ool0
1UJeIcUoogooLiag_@9oo`04MkecW7ooOol2Li`3Ool015kgDYAF]G_N0goo17>L1Goo00AkgTYB@Q1J
ePEoo`03Liag_Goo00=oo`03F]IBU6Li00=oo`05MkecW7ooOomkgP04Li`00g_NLiakgP02Ool01FLi
OomoogNmLi`01Goo0W>L1Goo00MkgW>LOomoogNmLiakgP02Ool016LiDYABU7>L0goo0W>L0goo00=k
gW>LLi`00W>L0Woo00=[FU:DE[D00goo00Ag_E:DE[Eg_@9oo`03LiakgWoo009oo`04G_MBU5JeMkd3
Ool00g>LMkeoo`03Ool015:DJeYg_G>L17oo0W>L00=kgW>LLi`00W>L1Goo00Ag_DYBAS5W>@Aoo`04
MkeBU5:DKg/2Ool00g_NLiakgP02Ool017>LMkeoogoo17>L00=kgWooOol01Goo00AcW4ic@Q1F]@Ao
o`04NmiF]E:DIcT3Ool01G>LMkeoogooJeX00Woo00=g_G>LOol00W>L1Woo00Ag_E:DDYAS60=oo`03
NmicW7oo00=oo`04IcUBU7ooMkd4Li`00gooMkecW004Ool01U[FHaQoogooLiag_CIoo`00=Woo00=g
_B4800000`0000@e[GooNmhQ20@00003AS5oogoo0088@P=oo`03E[D002U:009oo`0=000HaWooOol]
J`@QOomF]@005:EoogNm5:D00`0000@48DicOomkgP@000Aoo`03Mkd@Q000008000035:E_Ngoo009o
o`03000@Q7oo009oo`059BT00000000mk`02Ool01Be[001W>Goo@Q00100000=F]@008@P00Woo00H4
8F<HOolU:@00Li`3Ool015[F000007_N17oo00U6<@00E[E[FP00125g_Goo<H`0100000De[GooOol<
H`@Q00=oo`03BU80000000800003G_MBU0000080000448AcW6Li124200001@@QIcUNm`00<H`00Woo
00HU:@00000000@Q@Q02Ool00`005:Eoo`02Ool01THa000icS6<001F]@=oo`03248005Je00<00003
125oogoo009oo`03IcT48@00008000059BUoogooLi`8@P0300001Cg_OomF]@00BU800Woo00D002e[
Oomooa2400<00003<Haoogoo00Aoo`03>Lh000000080000536=oogooF]H8@P0300000acWLiaoo`02
5:D2Ool02A24BU9ooc6<001S6248001g_@04Ool00f<H2480000200001QS6Kg]oocW>001F]@9oo`05
Nmh<H`00NmhicP0300001@aSOolDY@00Nmh00Woo00=S60007>L00Woo00<48@Q2Ool0=Goo000fOol0
6AcW000001247>L48AS6Oom:DP00124mkd8@248004HaOolQ2000Liaoog_N48@001BU009oo`0@36<4
8GooOom6<@00Kg/HaP00DYAoocW>0008@THa?Nl2124015[FOol<H`000T8@00]kgWooOomoocF]000<
Hc6<2480012400=oo`0C5:D007ooOomg_@Q28@QNmacW001[FWoo@Q0004icOomF]@007>L00T8@00]c
W1BU125kgV]J000]Jgoo<H`006mk00=oo`04Li`00000IcT4Ool025kg0016<C6<000icWooF]H20000
2Cg_@Q0<H`00=JeoobDY001_N`02Ool00ekg000HaP02@Q0076mk:DX48EJe@Q0003F]BU8004YBCW<4
8B48Mkd001cWOom>L`00249243g_124004HaOol@Q0@Q0Woo00MkgP@Q000U:GNm124Li`02HaP01U:D
000DYG>L000@Q0924008NmioogooOol@Q00036<]J`80000<<Haoocg_000mkekg5:D005JeIcT003F]
0Woo00T@Q1S6OomoobDY000e[D8@DY@01Goo00M6<@0000048AcW48@00002Mkd05@Q2000Q24YB6<H0
00aSLi`e[@00Kg]kgP0036=ood8@001S63F]001S6004Ool02`aS000U:DYB8@P000@QLiaBU000@Q00
0Woo00M:DP00001W>DYB000U:@02@Q0017oo;F/006mk0Woo00<HaP0024800Woo00<Li`00Mkd0=Goo
000eOol015Je000004Ha0Woo00IkgTHaOolQ2000E[D2Ool037_N6<H006]J=Jd005kgOole[@001240
009oo`09:DX006]JOomNm`00<H`001cW009oo`0348@48F]J009oo`07Li`<H`@QMkdU:@00Kg/01Goo
00QcW2DYNmioog>L124005Je0Woo00<]J`00JeX00Woo00icW7NmOomS6000AS5ooe[F000icWooKg/0
02DY0goo00A24000DYA>L`800004Kg/aS000HaP4Ool00`Q2001>L`04Ool02W>L000U:@@Q249kgWoo
;F/005Je0Woo00MkgQcW001S63W>001JeP02Ool00gNm000HaP04Ool01f]JOomoo`aS48Aoof]J009o
o`09;F/007Nm36<8@Woo6<H006Li009oo`0>Li`DY@@QLi`YBP00JeYoocF]00048@aSOom6<@D00004
=Jeoo`@Q48@6Ool01F<H7>MkgWooE[D00P0000=cW36<00000Woo00I_N`007>Mg_@007>L2Ool01bU:
249oogoo?Nl005Je00Ioo`05Nmh48@006<Ig_@02Ool01EJeJeY>L`006<H00goo00LicP008@QNm`00
@Q1Nm`02000024ic@Q0005[FBU8004YBNmh2Ool00e[F000Q2003Ool02DHa000]JfLi000]JgooMkd<
H`02000014icHaP0048@0goo00e24000F]Iood8@00048@00MkeoocF]001Nm`0eOol003Eoo`03=Jd0
00Q200Ioo`037>L007oo00=oo`0BF]H0036<CW<004HaIcT00248:DX006LiOolicP00E[Eoog>L0`00
00DQ27>LOol<HaS600Aoo`06BU8004Ha>Lh005[F2Woo00<<H`00@Q000Woo00<mk`00BU8017oo00QB
U1240016<GooKg/002DY0Woo00l48@Q2@Q1245kgMkd00248>Lh001cW8@PaS000HaP017oo00DLi`00
<HacW7Nm00=oo`08248000006<IW>Goo8@P000Aoo`0;Li`002e[DY@00248@Q1:DWoo36<48@02@Q00
1e[FOomoofLi9BT00124009oo`0:Li`e[@00001kgR48001_Na2436<4Ool05V<H001243g_001F]Fmk
000aS1S6001g_Goo48@DYGoo>Lh005:DOolDY@002Woo00M[FP00001BU48@001cW002Ool01A24125o
o`aS12400Woo00Lmk`00MkeooeJe000Q2002@Q04Ool016<H000006<H1Goo00=24000?Nl017oo00dD
Y@00Kg/48ABU@Q0002DY5:Dmk`00DYAW>@0300001A24F]IBU000@Q0017oo00hLi`@QNmh001BUOola
S000BU8003W>Nmh001S60T8@00i[FU[F0016<FLi124DYCF]001W>GooBU8004YB=Goo000eOol00c6<
000Li`06Ool00bDY001kgP03Ool047>L000Q26<H000]JbU:001_Ncg_001F]GooDY@0048@0Woo00P4
8A24=Jd48A24MkdHaPaS17oo00IS6000<Ha>L`00AS48Ool01E[F8@P00000AS400Woo00@HaP0036=g
_@9oo`058@P000006<IkgP02Ool01@@Q36=oogoo5:D00`0000/]Jgoo7>L48ABU36=Nm`006<H006<H
00Aoo`03<H`00000008000067>M_Ngoo6<H8@Sg_0PQ200A_Nc6<001g_@Aoo`0336<HaVLi00<00003
249oob4800<000039BUoodic00800005125BU7ooIcT48@0200001d8@Oole[@00G_LQ20Q200Eoo`0F
000aS5:D000mkbDY249g_Be[001W>GooAS4005[F7>L006mkOol]J`00IcT8Ool015Je36<000000UJe
010005kgOomoobU:001_NacW001cW7ooE[D005kgOomW>@@00005JeYoogooOomJeP0200000g>LOomo
o`03Ool00eJe000e[@04Ool0436<001NmbU:000HaP@QMkd48ABU001BU7Nm000HaSW>0P@Q00=BU000
>Lh017oo00e24000Li`@Q000G_L0036<Kg/002DYOol<H`0300003T8@Kg/003F]7>L006<HBU8005:D
OomNm`00=JdeOol003Eoo`03>Lh000Q200Ioo`03BU8003W>00=oo`0@HaP00248Nmh000aS000icWoo
E[D003g_Oom[FP00:DX2Ool02ABU6<Ioocg_001BU3F]001>L`03Ool01U:D000aS6<H000]J`Moo`0>
8@P000000008@W>LOomW>@0036<0036<OomcW0800003BU9oogoo009oo`0;6<H007_NOol]J`00F]Ic
W7NmOom6<@0200000bU:OolHaP0200000f<HOomoo`02Ool04DYB000001cW124000aSNmhaS000OomF
]@00=JeNm`00=Jd00goo00IkgP@Q6<IkgP005:D2Li`02goo=Jd005:DLiag_Goo8@P002U:Kg/00Woo
00@e[@006<IW>@9oo`06BU8004HaCW<004YB0goo011[FP00<HaW>@0036<003W>Oom6<@00CW=oog_N
248Li`88@P9oo`03?Nl005Je00Ioo`03NmhQ2000008000055:Eoof]J001:DP02Ool02SW>001S63F]
001NmgooIcT004YB0Woo00@00124LiacW0Aoo`04JeX00000JeX5Ool017_N12448GNm0goo00@Li`00
HaQF]@8000036<IoocW>00800008DYAoo`aS7>Moocg_001:DP8<H`0BNmioogooOolYBP00Li`YBP00
36<48FmkOol48@aSOolQ20Q20W>L00ikgWoo1248@P00;F]ooekg0016<GooLi`00248=Goo000eOol0
16<H000006]J1Goo01IkgPaS000mkgNmNmhLi`00@Q1oo`Q20008@W_NOomW>@00:DYoog_N000HaP9o
o`079BT48Goo@Q00048@Kg/00P@Q00U:DWooKg/HaP00DYAkgP006<H01Woo00I>L`000000036<Li`2
Ool032e[001:DRU:001Nmg_N1248@WooMkecW09oo`07;F/006mkOolmk`00DY@00goo00IcW0000016
<GooF]H200000f<HOomoo`02Ool06Ukg000007_NKg/48@00BU96<@00Kg]BU000:DYooacW000mkgNm
NmhYBP00?Nmoo`aS1243Ool00dYB001:DP03Ool06Be[001F]GooJeYoodHa000mkgooJeYooekg000e
[Goo48@48DHaNmicW1cW001>Lgoo00800006125g_GooE[D003W>0Woo00A24000000U:@9oo`03E[D0
03g_00Ioo`05@Q00000036=24003Ool02P00=JeoogooCW<005:DBU8004YB0Woo00H003W>Oomoo`aS
1247Ool00`Q2000mk`06Ool024YB000LifmkOom6<@001242Nmh01@@Q000icWooKg/00P00019BU7oo
7>L@Q7oo>Lh0048@E[D001cWJeYoodic000<Hgoo>Lh2000023F]OomooaBU001kgSW>0004Ool021S6
0008@WNmOomg_@00<H`2Ool00`@Q36=oo`0dOol003Ioo`035:D002e[00Ioo`03IcT<H`0000<00006
48Ag_Goo7>L004Ha0goo00<001S6>Lh0100000@LicF]00048@800004G_Mooe[F124400001B48Oomo
o`aS12401Woo00A24000125_N`=oo`03Nmh48@00009kgP0536<8@WNm>Lh0000236<00aS6E[D00003
00000`aSE[D0000300001FmkOolHaP00G_L00Woo00<HaP00HaP017oo00]_N`00001[FWoo:DX002DY
F]H000@Q00800004BU9oog>L36<4000010Q2NmioobDY0`0000<icUkg00000`000VLi014000@Q7>L0
06]JMkd<H`007>L48DicMkd001cWOomS60Q200@000065:Eoogoo36<0048@0Woo00=_N`009BT00goo
00<<H`00?Nl00Woo00=[FP00:DX01Woo00@aS0005:EkgPAoo`0;36<Q27ooOomW>@00?NmJeP00=JdY
BP0400000cg_9BT0000200000acWOomoo`02Ool013W>00048Fmk1Woo00<mk`0000000`0000I247oo
OolYBP00DY@2Ool01BU:001BU7oo=Jd0100000=Nmgoo=Jd01@0000I6<GooCW<000aSNmh2Ool012e[
001W>DYB100000AkgRU:0016<@=oo`03248Q23F]00@000039BUoogoo035oo`00=Woo00Q[FPQ2000]
JekgMkeNmacW0Woo00IkgTic<H`YBT8@Nmh2Ool00dYB;F]kgP03Ool00dYB@Q1W>@04@Q001TYBHaQ2
448@AS5W>@=oo`05Mke:DRe[;F]:DP03Ool00e:D@Q1oo`05Ool01Ukg00048FLiOomJeP9[FP09@Q1B
U7ooOomS648@G_MooeJe008aS003HaQg_D8@00A24003Lia2448@00924004LiaooeJe:DX3Ool00fLi
:DY_N`05Ool020@Q001BU6Li48@002DYMkd2@Q000dHaG_Moo`03Ool01Dic<H`YBSg_Li`00Woo00IJ
eT8@@Q1245JeNmh4@Q001V]JOom[FSW>;F]:DP9oo`08MkdmkbU:@Q1kgWoo@Q1:DP9oo`06Mke:DRe[
;F]247Nm0Woo00=2436<Ool00goo00=244icOol00Woo00=JeRU:IcT00goo00=244icOol01Goo00Y>
L`0048Ag_GooCW=g_GooDYA:DP9oo`07Nmi245[FNmi245JeG_L0148@00=F]Ekg@Q000T8@00=:DWoo
Ool00Woo00UkgQcW0008@TYBKg][FS6<G_L00Woo00ES63W>:DXe[Ekg00=oo`03G_LYBW>L009oo`05
Kg/YBV<HOomS6002@Q000dYBIcUoo`02Ool01Ekg>LhYBS6<F]H00Woo00=_NbU:F]H00goo00ANmd8@
Kg]_N`A24003MkeBU36<00Aoo`03CW=:DVLi00A24003DYAoogoo035oo`00=goo00=[FPaS00001000
00=_NgooOol0;Woo00HQ2000000<H`0048@WOol00acW0000000300000dicOomoo`1<Ool01QcW0004
8@Q2000HaQaoo`039BT0000000<00003BU9oogoo071oo`00>7oo00=cW2e[24800P0000<HaWNmOol0
<7oo00DaS0@Q000<HdYB02Moo`06AS4Q22488@PYBU:DCgoo00IkgRU:000001BUF]HMOol01U:D6<H0
000048AF]G9oo`00>goo00=cW7_NOol0=7oo00=cW7ooOol0OWoo0W_N8Goo00=kgWNmOol0Lgoo003o
Oon=Ool00?mooheoo`00ogooSGoo003oOon=Ool00?mooheoo`00ogooSGoo003oOon=Ool00?mooheo
o`00ogooSGoo003oOon=Ool00?mooheoo`00ogooSGoo003oOon=Ool00?mooheoo`00ogooSGoo0006
Ool00dic=Jde[@02=Jd00cW>Oomoo`05Ool00e:D=Jde[@03=Jd00fLiE[De[@04=Jd00dHaF]Ig_@0<
Ool01DHa=Jde[C6<Mkd00goo00=cW3F]=Jd00SF]00=W>GooOol00goo00MBU3F]=Jde[C6<JeYNm`04
=Jd00g>LOomoo`02Ool01Dic=Jde[CF]?Nl027oo00QJeSF]9BTLib48=Jeoof]J23F]00DmkgooOoli
cS6<00<e[@03?Nm:DUkg00ioo`03Mkde[CF]00<e[@03F]Ioogoo00=oo`03Mkde[CF]00<e[@03JeYo
ogoo009oo`09Lia6<BDY5:D<Ha247>LaS5:D00Aoo`03@Q0e[CF]008e[@04NmioogooKg/3=Jd01Ekg
Oomoogoo@Q000cF]00<mkgooG_L023F]00<mkgooOol013F]00EBU7ooOomoodic00@e[@03Liaooekg
00<e[@03<Hag_Goo00Ioo`07JeY242U:6<HLibe[DY@013F]00=_NgooOol00goo00=:DS6<=Jd00SF]
00=cW5Je=Jd01cF]00=247ooOol01Goo00=F]CF]=Jd00cF]00ENmgooOomoog>L00@e[@05HaQoogoo
Oom_N`05=Jd00eJeOom>L`08=Jd00e[FOomoo`02Ool4=Jd00d8@Oomoo`02Ool00fmk=Jde[@02=Jd0
1FLiOomoogooKg/013F]00=JeWooOol017oo00M6<BDY48@<HaBU<HaNm`06Ool00d8@=Jde[@02=Jd0
13g_AS5Nmg_N1goo00=_Ncg_8@P00PaS00<Licg_JeX03Woo0006Ool00eJe0000000300000f<HOomo
o`04Ool00bDY0000000300000ekgBU80000700000bDYIcUoo`09Ool01@Q200000000@Q0017oo00D<
H`00000002DY00Eoo`03;F/0000000800003HaQNm`0000<00003F]Ioogoo009oo`0536<000000008
@P06Ool00ekg48@0000500000g>LJeX0000800000g_NOolHaP0700000`Q2@Q1oo`0<Ool500000c6<
Oomoo`03Ool00e:D0000000300001TYBOomoogooJeX8@PP00005249S67ooOol]J`04000015[FOomo
of<H0`0000DU:GooOomooacW00@00003OomBU00000P0009oo`0548@00000000Li`03Ool00aBU0000
00020002Ool00eJe0000000200000f<HOomoo`03Ool00gNm9BT0000500000cg_2480000200000cF]
Oomoo`03Ool00b480000000200000g>LCW<0000700000`Q2Oomoo`05Ool00e:D0000000300001C6<
OomoogooF]H0100000DYBWooOomoog>L00D00003<Haoocg_00P00003:DYoogoo009oo`0524800000
0008@P04Ool00gNm0000000200001D8@OomoogooMkd0100000<aS7ooOol00Woo00=g_ABU00001P00
00<LifmkOol00goo00<YBP0000001@0000<48BU:Li`01Goo00<U:@0000001@0000<e[GooOol02goo
0007Ool00`Q20000000200000c6<Oomoo`04Ool00b480000000300000fLiE[D0000800000`@Q?Nmo
o`07Ool00g_N0000000200000`aSOomoo`02Ool01SF]00000000125g_@Aoo`038@P0000000800003
Lia_N`0000<00005AS5oogooOom_N`0500000gNmOomoo`02Ool00f<H0000000600000ekgOol00008
00000f]JOol]J`0900000aBUKg]oo`0:Ool00aBU0000000200000acWOomoo`03Ool00c6<00000003
00001CW>Oomoogoo9BT02P0000@48FmkOom>L`@00004AS5oogooE[D4000017NmOomoobU:100000=o
ofLi0000200000=[FWoo8@P00`0000@8@WooOomkgP@000045:EoogooIcT400000dYBOomoo`02Ool0
0g>L36<0000600000be[=Jd0000200000`Q2Oomoo`03Ool00aBU0000000200000gooHaP000080000
0g_NOomoo`04Ool00g>L0000000300001AS6OomoogooF]H0100000<48GooOol00Woo1@0000<aS7oo
DY@0200000<DYGooOol00Woo00<Q200000000P0000=kgWooOol00Woo00D48@00000002U:00Aoo`05
24800000000Q2004Ool00bDY0000000700000`Q2IcUoo`02Ool00cg_0000000700000`aSHaQoo`03
Ool00c6<0000000600000be[Oomoo`0:Ool000Moo`03=Jd0000000800003249kgWoo00Aoo`035:D0
000000<00003Lia[FP0000X00003@Q1oogoo00Eoo`03JeX0000000<00005CW=oogooOomNm`040000
0dYBOomoo`02Ool00acW0000000200000g_NOol48@0300001Be[OomoogooCW<01@0000=S67ooOol0
0Woo00<<H`0000001P0000=:DWoo5:D0200000=F]Goo@Q002P0000<8@V]JOol02Goo00<YBP000000
0P0000<8@WooOol00goo00<@Q00000000`0000@Q27ooOomoo``00003;F]oofmk00@00004:DYoogoo
DY@4000015:DOomooc6<100000=g_G>L0000200000=JeWoo<H`0100000=g_GooF]H0100000@]Jgoo
Oomoo`@00003>Lioogoo009oo`037>L0000000H000037>MW>@0000<00003E[Eoogoo009oo`0748@0
000000048GooNmh02@0000=S67ooOol01Goo00<<H`0000000`0000AkgWooOomJePD00005G_Moogoo
Ool8@P0400000b48OomW>@0800000`@QOomoo`02Ool00cF]0000000200000fLiOomoo`02Ool01AcW
000000006<H017oo00DHaP00000001BU00=oo`03F]H0000000T0000536=g_GooOomBU00:00000`@Q
HaQoo`02Ool00dHa0000000700000dicOomoo`09Ool000Moo`03Kg/0000000<00003E[Eoogoo00=o
o`0348@0000000<00003OomkgP0000<00003248U:@0000@00003125W>Goo00Eoo`03E[D0000000<0
00036<Ioogoo009oo`0524800000000<H`048@P00`@Q000000020002Ool01AS6000000006<H00goo
00<]J`0000000`0000E:DWooOomood8@00H0000648@]JacW>LioobU:1000112400=:DWooF]H01000
00<Q21S60000100000<@Q7_NOol027oo00<mk`0000000`0000Eg_GooOomoog>L00H0000436=oogoo
Li`500000cg_F]He[@04000010@QOomoo`aS0`0000@@Q7ooOomBU0@000048@Qoogoo>Lh400000g>L
Ool48@04000448@00dicOom2400400000f<HOom2400400001D8@Oomoogoo48@00`0000DU:GooOomo
oeJe00H00006248U:BU:5:Eooa240`0000<@Q2488@P00R4800D48@0000000124009oo`0536<00000
00048@0448@00e[FOomoo`05Ool00be[00000003000016LiOomoodic1@0000DicWooOomooa2400@0
00038@Qoog_N00@00003124@Q124008@Q005LiaoogooOom:DP0400000eJeOomoo`02Ool01Be[0000
0000124017oo00<aS00000000P000goo00<YBP0000000P0000@8@THaAS4<H`@000048@QoogooIcT4
00000aS67>L0000400002P@QLiaoogooE[D001cW?Nm24248100000<8@WooOol02Goo0008Ool00aBU
0000000200000`@Q48@@Q00348@00`@Q00000002000010@QOomoo`Q20`0000@8@WooLi`Li`@00003
5:Eoogoo00Aoo`03BU80000000@00005HaQoogooOolicP0<00001124OomoobU:0`0000D8@WooOomo
oa2400D00005>LioogooOol<H`0500000dicOomoo`03Ool00cW>0000000200000g_NOomoo`03Ool0
0f]J00000002000014YBOomS60Q2100000<e[GooOol01goo00=BU00000000`0000ENmgooOomooe:D
00L00003Nmioog>L00@000058@QoogooOole[@0400000ekgOol]J`0400000gNmOom6<@04000010@Q
Mkeood8@100000=_Ngoo6<H010001Woo00=BU00000000P0000=>Lgoo9BT0100000EJeWooOomoobDY
00<0000536=oogooOolYBP0500000cF]Oomoo`03Ool00cg_0000000:000011cWOomooacW0`0000<D
YGooOol02Woo00=>L`0000000`0000A:DWooOom>L`D000055:EoogooOolQ2004000011S6Oomoo`aS
0`0000<YBWooOol01Woo00=Nm`0000000P0000=6<GooOol00Woo00=6<@0000000P0000E_NgooOomo
odHa00@00004Kg]oogoo124400001EkgOomoof]J1240100000=NmgooNmh0100000@icWooJeXDY@@0
00059BUoogooJeYNm`04Ool00cF]0000000200000dicOomoo`08Ool000Qoo`03AS40000000d00004
48Aoogoo8@P4000017NmOomoob48100000=6<GooOol00goo00<e[@000000100000DQ27ooOomoofmk
00`000046<IoogooAS4400000g>LOomcW00600001248Oomooe[F1@0000=F]GooOol017oo00=F]@00
00000P0000=S67ooOol017oo00D48@00000003F]009oo`03IcT0000000<00003JeYoogoo00Ioo`03
JeX0000000<00005BU9oogooOol]J`0700000f<HOomoo`0400001C6<OomoogooKg/0100000=247oo
DY@0100000=Nmgoo@Q001@0000=:DWooCW<0100000=S67oo;F/0100000=[FWooOol00goo00=S6000
00000P0000<icWoo2480100000Eg_GooOomoocg_00@00004Nmioogoo248400000bU:Oomoo`04Ool0
0f]J0000000:000012DYOomoocF]100000=kgWooOol02Goo00=cW00000000`0000@]JgooOom:DPH0
0004JeYoogoo;F/400001124OomooacW0`0000<<HgooOol01Woo00=g_@0000000P0000<e[GooOol0
0Woo00=JeP0000000P0000EJeWooOomooekg00@00003E[Eoof]J00@0000348Aoogoo009oo`03BU80
0000008000049BUoogoo48@300001BDYOomoog_N6<H0100000=JeWooOol01Goo00=g_@0000000P00
00<YBWooOol027oo0008Ool00g>L0000000=00001248OomoocF]100000EW>GooOomkgPQ200<00003
36=oogoo00=oo`038@P0000000D00005IcUoogooOolYBP03000010@Q48@@Q124100000@U:GooOomJ
eP@00003F]Iooe:D00H00004249oogoo>Lh400000acWOomoo`05Ool00f]J0000000200000dYBOomo
o`04Ool01AS6000000006<H00goo00=2400000000P0000<mkgooOol01goo1@0000De[GooOomoo`aS
00L00004CW=oogoo48@300000acWOomoo`02Ool01`Q200000000:DYoogNm00@00003@Q1oocg_00D0
00036<Iooe[F00@00003G_MoodHa00@00003F]Ioogoo00=oo`03Nmh00000008000037>M_N`0000<0
000348Aoogoo009oo`03DY@0000000800003HaQoofLi00D00003Liaoogoo00Eoo`036<H000000080
00<@Q0@00004<HaoogooCW<400000f]JOomoo`0:Ool00aBU0000000200001124Oomood8@1P0000@i
cWooOolicP@00004249oogoo;F/400000g_NOomoo`06Ool01@Q2000000008@P017oo00=cW0000000
0P0000E247ooOomoogNm00@00003@Q1oof<H00@00003:DYoogoo00=oo`0836<0000000048G>LOolU
:@<0000636=oogooOom_N`@Q0`0000<HaWooOol01Woo100000<@Q7ooOol027oo0009Ool00acW0000
000<000012U:Oomoodic100000EBU7ooOomoocW>00@00003G_Moogoo009oo`0548@0000000048@03
00001BU:OomoogooF]H0100000=g_GooOol0100000@aS7ooOom_N`@00003AS5oocg_00L00003Mkeo
obU:00@00003AS5oogoo00Ioo`@00003=Jeoogoo00Aoo`05:DX000000008@P03Ool00g_N12400002
00000aBUOomoo`07Ool00aBU00000002000011cWOomoog>L200000@e[GooOolQ20<0000336=oogoo
009oo`057>L00000000DY@02Ool01aBU000000009BUooc6<00H00003Kg]S600000<00003DYAooe[F
00@00003AS5oogoo00Aoo`06248000000008@UJe100000<]JgooOol00Woo00=W>@0000000P0000=:
DWooE[D0100000<HaWooOol01Woo00=>L`0000000P0000=[FWooLi`0100000@mkgooOomS60@00003
DYAoogoo00Yoo`03=Jd0000000<00003Nmiood8@00H0000448AoogooAS450002Ool00cg_00000002
00000fLiOomoo`06Ool01AcW0000000048@01Goo00D48@00000002e[00Aoo`0724800000000YBWoo
HaP0100000<aS7ooOol00goo00<icP0000000P0000=>Lgoo?Nl0100000Eg_GooOomoob4800@00003
Kg]oogoo00Aoo`03G_L0000000800003249oogoo00Qoo`002Goo00=BU00000000`0000@]Jc6<<H`]
J`D00004<HaoogooG_L400001DHaOomoogooLi`0100000<icWooOol00Woo100000HQ2000000000@Q
Li`3Ool01@aS00000000DY@00Woo100000@mkgooOomoo`@00003<Haoob4800L00003HaQoob4800@0
0003G_Moogoo00Ioo`0536<00000000Q2003Li`017NmOomood8@100000Eg_GooOomooc6<00@00003
Mkeoogoo00Ioo`039BT0000000800004249oogooF]H8000012DYOomoobe[100000Eg_GooOomooc6<
00<00004125oogoo<H`300000`aSOolaS00600000d8@JeX0000300000e:DOom_N`0400001C6<Liac
W7>LMkd00Woo00<HaP0000000P0000<e[@0000000P0000=:DWooOol00goo100000<icWooDY@01000
00<]JgooOol01Woo00=kgP@Q00000P0000=>LgooLi`0100000A:DWooOomg_@@00003?Nmoogoo00Yo
o`03E[D0000000<00003HaQoocF]00L00003HaQooe:D00D0009oo`03DY@0000000800004AS5cW7>L
Li`5Ool00cF]000000020005Ool01ABU000000006<H017oo00LHaP00000001S6OomS600400000be[
Oomoo`03Ool00f<H0000000200000bDYOom>L`0400001FLiOomoogooCW<0100000=:DWooOol00goo
00=W>@Q200000`0000<DYGooOol027oo000:Ool00`@Q00000002000015JeOomoog>L1@0000A247oo
Oomg_@@00003<Haoogoo009oo`055:D00000000HaP03Ool00g>L0000000200000d8@000000020000
1Cg_Oomoogoo?Nl00`0000<U:GooOol0100000E247ooOomooaBU00<000037>Moo`Q20080000348@0
000000800003CW=oob4800@00003HaQoogoo00Ioo`038@P0000000D0000448AoogooE[D400001Ekg
OomoogooE[D0100000=JeWooOol01Woo00<mk`0000000`0000=g_Goo?Nl0200000@<HgooOom240@0
0005IcUoogooOom:DP0400000fmkOomBU00400001W>L;F/0000036<48@80000348Ag_@0000<00004
@Q1oogoo1247000011BUOomooc6<100000<@Q00000000P0000=W>GooOol00goo00L<H`00000002DY
OomBU00400000c6<Oomoo`07Ool01c6<00000000:DYoog>L00@00005DYAoogooOol8@P0300000bU:
Oomoo`0:Ool00g>L0000000300000dHaOole[@0700000cW>OomNm`0500000g>LOomS600800000cg_
Oomoo`02Ool00dHa0000000200000f]JOomoo`02Ool00bDY00000002000448@01`@Q00000000125o
ofmk00@000038@Qoogoo00Aoo`07124000000008@WooIcT0100000E>LgooOomoof]J00@00003:DYo
ogoo009oo`03CW<48@0000@00003>Lioogoo00Qoo`002Woo00<e[@0000000P0000@aS7ooOomcW0D0
0005AS5oogooOol8@P0300000b48Oomoo`02Ool01Be[0000000012400goo00=Nm`0000000P0000=B
U1S600000P0000D8@WooOomoofmk00<00003125kgWNm00@00005DYAoogooOolQ200300000`Q2JeX0
000200000c6<0000000200000cW>Ool]J`0400000ekgOomoo`06Ool00be[0000000600000g_NOom[
FP0400001DYBOomoogooLi`0100000=247ooOol01Woo00=>L`0000000`0000=S67oo9BT02@0000=k
gWooDY@0100000E>LgooOomooe[F00@00003F]Ioog>L00@00006F]HQ2000000@Q2DY0`0000=_N`00
00000P0000A247ooOolDY@L00004125oogooAS4900000aBUJeYoo`03Ool01bDY0000000048Aooe[F
00@00003<Haoogoo00Moo`07HaP000000008@WooLi`0100000ENmgooOomooacW00<000035:Eoogoo
00]oo`0348@0000000800003;F]oocF]00L0000348Aoof]J00D00003Liaoog>L00P00003;F]oogoo
009oo`03G_L0000000800003F]Ioogoo009oo`03<H`0000000/00003Kg]kgP0000<0000348Aoogoo
00Aoo`036<H0000000800003LiakgP0000<00003?Nmoogoo009oo`0512400000000@Q003Ool00cg_
0000000400000`Q2Mkeoo`09Ool000Yoo`03Kg/0000000800004125kgWooLi`500001EJeOomoogoo
8@P00`0000<@Q7ooOol00Woo00=:DP0000000P0000A[FWooOom>L`@00003G_MBU00000<00005DYAo
ogooOolYBP0300000e:DLi`0000300001E[FOomoogoo=Jd0100000I6<@00000005Je5:D300000b48
Oom6<@0400000dYBOomoo`06Ool00d8@0000000600000f]JOomoo`0400000cF]Oomoo`02Ool01@Q2
00000000:DX027oo00=[FP0000000`0000=:DWoo24800`0000<DY@0000000`0000=W>GooHaP01000
00DicWooOomoog>L00@00004@Q1oogoo5:D300001Sg_8@P0000048ABU0<00003CW<<H`0000800004
=Jeoogoo;F/800000f]JOomNm`0:00000`Q2IcUoo`02Ool00cW>0000000200000g_NLi`000030000
0aS6Oomoo`08Ool01QcW00000000G_MS60@00005JeYoogooOole[@0300000`@QOomoo`0;Ool00cF]
0000000200000a24OolYBP0300000a240000000200000ekgMkd00004000016<HOomoo`@Q1`0000<D
YGooOol00Woo00=cW00000000P0000=247ooOol00Woo00=:DP0000002`0000=JeWoo48@0100000=k
gWooOol00goo00<aS00000000P0000=JeWoo36<00`0000<U:GooOol00Woo00<DY@0000000P000Woo
00=:DP000000100000<<Hf<HOol02Woo000;Ool00bDY0000000200000eJeOomS600500001F<HOomo
ogoo=Jd0100017oo00=BU00000000P0000AS67ooOolicP@00003JeYoo`aS00<000058@QoogooOomS
600300000bDYLi`0000300001FLiOomoogooBU80100000HDY@00000007_N9BT300000`aSOomS6004
00000b48Oomoo`06Ool00eJe00000006000014icOomooaBU0`0000<LigooOol00Woo00D@Q0000000
024800Uoo`D00003=JeW>@0000<00003>Lh0000000<00003CW=oogNm00@000038@Qoogoo009oo`05
12400000000]J`02Ool01SW>000000007>LQ2080000348AkgP0000800003;F/DY@0000800004<Hao
ogooAS4800000eJeOomcW00400000aS6@Q0U:@0400001@Q2NmioogooDY@0100000=W>Goo36<01000
00=kgWooOol01goo00IBU0000000036<HaP400001G>LOomoogooBU80100000=W>GooOol02Woo00=J
eP0000000`0000=cW2U:00000P000R480`0000<aS7oo0000100000AS67ooOolHaPP000Eoo`052480
0000000YBP04Ool00e[F0000000;00000d8@Ool]J`0400000ekgOomoo`03Ool00d8@000000020000
0dYBOolYBP0300000`aSOomoo`02Ool00b480000000200000gNmNmh48@0500000aS6Mkeoo`0;Ool0
00]oo`03F]H0000000800003:DYoof<H00D00005JeYoogooOom:DP0400001F]JOomoogooDY@01000
00ABU7ooOolYBP@00003Mkeood8@00@00005Kg]oogooOol@Q00300000fmk0000000200001G>LOomo
ogooE[D01`0000<HaWoo?Nl0100000=kgWoo36<00`0000<48GNmOol01Woo00=S600000000P0000D]
Jg>LLiacW7_N009oo`058@P000000008@P04Ool01A240000000048@02Goo00<@Q00000000P0000<U
:DYB00000`0000=W>@0000000`0000@icWooOol8@P<0000336=oogoo009oo`057>L00000000DY@02
Ool01U[F00000000248Q2080000348Aoob480080000348@Q200000800004:DYoogooF]H400001Dic
LiacW7>LNmh00Woo00D8@P0000000248009oo`03E[D0000000800004>LioogooIcT400000dicOolY
BP0400000dYBOomoo`08Ool01@Q2000000Q2G_L0100017oo00=S600000000P0000=F]GooOol02Woo
00=kgP0000000`0000=JeRDY00000P0000<Q248@00000P0000<8@Woo48@0100000AF]GooOol]J`@0
0004G_McW7>LLi`5Ool01AcW000000005:D017oo00=_N`0000000P0000<DYD8@@Q000T8@00L8@P00
000002e[Oom>L`0400000cg_Oomoo`03Ool00dic0000000200000d8@OolicP0400001G_NOomoogoo
8@P0100000=[FUkg0000100000<YBWooOol037oo000<Ool01`Q200000000125kgV<H00D00005Mkeo
ogooOomNm`0400001EJeOomoogooAS40100000ABU7ooOolDY@@0009oo`03Li`48@0000800005>Lio
ogooOom6<@0300000dHa000000020004Ool00f]J0000000500000cW>Oom>L`0400000f<HOolicP04
00000cW>Oomoo`05Ool00gNm0000000200000bDYOomoo`04Ool00c6<0000000200001GNmOomoogoo
24800`0000<@Q7ooOol01goo00<U:@0000000P0000<Q22U:00000P0000<8@Woo36<0100000@U:Goo
OolLi`@000Aoo`05<H`0000000048@02Ool00g_N0000000200001QS600000124Oom240<000058@P0
0000000Q2002Ool00f]J0000000200000dYBOomoo`04Ool01AcW000000005:D00goo00DYBP000000
0124009oo`03Nmh0000000800003>Liooe:D00@000035:Eoogoo00Qoo`05=Jd000000016<@030000
0`Q2Oomoo`02Ool00gNm0000000200000cg_Oomoo`0;Ool00aBU0000000200000cg_:DX000020000
0b48JeX0000300000f<H7>L00003000015:DOomoodHa100000=JeWooOol01Woo00DaS000000000@Q
00Aoo`03Nmh00000008000037>Moogoo009oo`076<H00000000HaWooLi`0100000<DYGooOol00goo
00=BU00000000P0000=247ooCW<0100000EW>GooOomooaBU00@00003IcUBU00000<000035:Eoogoo
00eoo`0037oo00<mk`0000000P0000=JeV<H0000100017oo00=g_@0000000P0000E247ooOomoobe[
00@00004HaQoogoo248300001@@QOomoogoo:DX00`0000H8@W_NOomoogNm124200001AcW00000000
124017oo00=kgP0000001@0000=JeWooIcT0100000=>LgooLi`0100000<48F]JOol01Woo00D48@00
000000aS00Ioo`03AS40000000800004G_MoogooKg/400000b48Oomoo`07Ool00cW>000000020000
0a242480000200000bU:OolQ2004000010aSOomoobe[100000E[FWooOomoodHa00@00004Kg]oogoo
48@300001P@Q00000124Oom_N`<0000512400000000Li`03Ool01@@Q00000000=Jd01Woo00D]J`00
000000@Q00=oo`03E[D0000000800004JeYoogoo2483000012U:Oomoo`Q2100000=>LgooOol01goo
00E[FP00000001cW00<0000336=oogoo00=oo`0524800000000]J`0=Ool00be[0000000200000bU:
9BT0000200000b48Ool<H`0300000cg_9BT00003000014YBOomooeJe100000=:DWooOol01Woo00=:
DP0000000P0000=_NgooOol00Woo00D<H`00000000Q200Aoo`05;F/0000000048@02Ool00acW0000
000200000fLiOomoo`02Ool00dYB0000000200000d8@OomS6004000015:DOomoogoo1@0000=g_EJe
00000`0000=247ooOol03Goo000<Ool00fmk0000000200000c6<HaP0000300000`Q2Oomoo`03Ool0
1@Q200000000;F/00Woo00=g_@@Q00000`0000=cW7ooNmh0100000D@Q7ooOomooekg00@00005AS5o
ogooOolLi`0200001@@Q0000000048@01Goo00<8@P000000100000=kgWooNmh0100000@icWooOol]
J`@0000348Ag_Goo00Eoo`036<H0000000800003Nmioogoo00=oo`03E[D0000000800004CW=oogoo
>Lh400000c6<Oomoo`07Ool00dic0000000700000dYBOole[@050002Ool00dHa0000000200001E[F
OomoogooF]H0100000AJeWooOolYBPH0000448Aoogoo48@600001A24Oomoogoo5:D00`0000<Ligoo
Ool017oo00=6<@0000000P0000AcW7ooOomS60@00004G_Moogoo7>L300001124OomoodHa100000<8
@VmkOol027oo00<HaP000000100000<HaWooOol00goo00DDY@00000001S600eoo`03AS4000000080
0003248YBP00008000038@QoobU:00<000036<HaS00000<00004@Q1oogooKg/400000cg_Oomoo`06
Ool00e[F0000000200000e[FOomoo`02Ool00b480000000200001GNmOomoogooAS40100000=_Ngoo
DY@0100000<YBWooOol00Woo00<aS00000000P0000=>LgooNmh0100000@mkgooOomF]@D00003Oom[
FP0000<00003AS5oogoo00eoo`003Goo00HU:@00000000Q2G_L400000aBUOomoo`03Ool021cW0000
00006<Ioofmk7>L400001124Oomoof]J100000<Q27ooOol00Woo00DHaP000000012400=oo`03CW<0
000000@000036<Ioogoo00=oo`038@P0000000<000057>MoogooOol@Q00300001BDYOomoog>L2480
100000<@Q5:DNmh017oo00<aS00000000P0000=_NgooOol00goo00=W>@0000000P0000@e[GooBU84
8@@00003E[Eoogoo00Moo`03IcT0000000L00003Kg]oodic00D00003IcUooe[F00@00005BU9oogoo
OomcW004000014HaOomoodYB1P0000@@Q7ooOolicPH0000548AoogooOol]J`0300000`Q2Oomoo`04
Ool00e[F00000002000015[FOomoodHa100000ABU7ooOol]J`@00004Nmioogoo9BT400000`@Q@Q1_
N`07Ool00eJe0000000400000b48Oomoo`03Ool00bU:00000002000=Ool00f<H0000000300001aS6
000000008@Qoodic00@00003;F/0000000800005?NmoogooOol48@0300000bU:Oomoo`06Ool00g>L
0000000200000dHaOomoo`02Ool00cW>0000000200001F<HOomoogooF]H0100000AJeWooOolDY@@0
0005AS5oogooKg/8@P04000016LiOomoo`aS0`0000@U:GooIcT@Q0@000049BUoogoo48@300000aS6
Oomoo`02Ool00e[FIcUoo`08Ool000eoo`03G_L0000000800003>Lh00000008000038@Qoogoo00=o
o`03=Jd000000080000348@0000000@00004BU9oogooF]H400000be[Oomoo`02Ool00eJe00000002
00001DYBOomoog_N12401@0000<YBWooOol00goo00<icP0000000`0000E247ooOomoobDY00<00005
36=oogooOomW>@07000248@00`Q2Mke:DP0800000`Q2OomkgP0400000`@Q2480000400000`Q2Oomo
o`09Ool800001124Oomoof<H1@0000=>LgooLi`0100000<e[GooOol00Woo00D48@00000002e[009o
o`03IcT0000000@0000448AoogooIcT70003Ool00dHa0000000600000bDYOomcW00400000bDY@Q0]
J`05000016LiOomoocg_100000EW>GooOomkgQS600H0000436<@Q0Q2JeX4Ool00`aS000000030000
0bU:Oomoo`03Ool00cg_0000000200000f]JOomoo`0;Ool00`@Q0000000200001`@Q000000008@Qo
ofmk00@0000348@0000000800005<HaoogooOolHaP0800000cF]?Nl0000:00000eJeCW<000030000
1E:DOomoogooLi`0100000A6<GooOomJePD000037>L]J`aS00@0000548AoogooOolU:@0300000`@Q
36<00005000015[FOomoodYB100000HDYCg_@Q0Li`00DY@9Ool000ioo`0536<00000000DY@040000
0be[Oomoo`03Ool00dYB0000000800001ABUOomoogooCW<0100000<e[GooOol00goo00D<H`000000
01BU00=oo`03:DX0000000<00003<Haoogoo00=oo`03BU80000000<00005HaQoogooOolmk`040000
1W_NOomoogooF]H48@P00003JeYJeP0000P00003Mkeoo`Q200X00003@Q1oogoo00Uoo`0336<00000
00D00004<HaoogooNmh5000013W>Oomoo`@Q0`0000<U:GooOol00Woo00DLi`00000001S600=oo`03
1240000000<0000548AoogooOol<H`060003Ool00eJe0000000600001124Oomoo`@Q2P0000D<Hgoo
Oomooe:D00@00006CW=oogooOomg_ABU200000=F]GooOol00Woo00<aS00000000`0000<e[GooOol0
0goo00=:DP0000000P0000=F]GooOol02goo00<Li`0000001P0000@Q27ooOol@Q0P00005<Haoogoo
Ool]J`0800000b48CW<0000:00000dYBHaP0000300000d8@Oomoo`02Ool01@@Q00000000;F/00goo
00<aS00000002@0000E:DWooOomoocW>00X000038@Qoogoo009oo`0348@0000000H00003?Nmoogoo
00Moo`003Woo00<e[@0000001P0000<e[GooOol00goo00=Nm`0000001`0000<@Q6mkOol00Woo00=2
400000000P0000=247ooOol00goo00<mk`0000000P0000ANmgooOomNm`D00003@Q1oogoo00=oo`03
HaP0000000800003125oogoo009oo`03CW<0000000800003IcUoogoo009oo`03IcT@Q00000H00003
E[E_N`0000P00003G_MooacW00T000038@Qoogoo00Yoo`037>L0000000D00005DYAoogooOol8@P04
000012DYOomooaS60`0000<DYGooOol00Woo00D]J`00000000@Q00=oo`037>L0000000<0000548Ao
ogooOolaS006000017NmOomoofmk200000@48GooOolHaPX00005E[EoogooOomS600400000cg_Oomo
o`02Ool00g_N:DX0000600000cg_Oomoo`02Ool00eJe0000000300000cg_Oomoo`03Ool00ekg0000
000200000d8@Oomoo`0;Ool00cg_0000000600001248OomoocF]200000DQ27ooOomood8@00P00003
36=Nm`0000X00003=JekgP0000<00003;F]oogoo009oo`056<H00000000HaP04Ool00be[00000007
00000aBUOomoo`02Ool00dic0000000700000aS6Mkeoo`03Ool00fLi2480000600000be[Oomoo`07
Ool000ioo`03G_L0000000H00003@Q1oogoo00=oo`03Li`0000000H00003:DYkgWoo00=oo`03<H`0
000000800003DYAoogoo00=oo`03Li`00000008000059BUoogooOol@Q00400000dYBOomoo`03Ool0
0gNm0000000200000acWOomoo`02Ool00fLi0000000200000e:DOomoo`03Ool00g_N?Nl48@050000
0dYBOol48@0800000dicOolaS00700000`Q2AS5oo`0<Ool00be[0000000500001G>LOomoogoo6<H0
100000@@Q7ooOol]J`<00003249oogoo009oo`03AS40000000800004Liaoogoo?Nl500001ABUOomo
ogooE[D01P0000Ag_GooOomoo`T00003Kg]oobe[00P0000348AJeWoo00=oo`03Li`0000000800003
:DYoogoo00Aoo`03CW<8@P0000@00003;F]oogoo00=oo`032480000000800003@Q1oogoo00=oo`03
Kg/0000000800003;F]oogoo00]oo`03G_L0000000H000048@QoogooE[D800001B48OomoogooE[D0
2@0000=[FP0000002@0000<U:Goo36<00`0000<Q27ooOol00Woo00D]J`00000000Q200Eoo`03AS44
8@0000D0000336=[FWoo00=oo`03HaP0000000D00003124mkg_N00Ioo`03IcT@Q00000D000039BUo
ogoo00Moo`003goo00<8@P0000001@0000=>LgooOol017oo0d8@00DicS6<?NmBU7>L00Ioo`03E[E2
448@00924003JeYoogoo00Aoo`03CW=2448@009240=oo`03G_M2448@00924003JeYoogoo00Aoo`A2
4003F]Ioogoo009oo`03Nmi2448@00924003HaQoogoo00Eoo`09Mke6<BU:6<H@Q2DYG_MoodYB00Q2
4003HaQoof<H00=2408e[@03AS5Nmgoo00ioo`03?Nl0000000@0000348Aoogoo009oo`03:DX00000
00<0009oo`03HaQ2448@009240Aoo`03JeY2448@00924004LiaoogooJeX5@Q001E:DOomoogooNmh0
1T8@17oo00=:DT8@@Q001T8@00=cW7ooHaP01T8@00=:DV<HOol01Woo148@00=>LgooOol01Goo00Mk
gUJe=JdLia247>M>L`05Ool00eJe@Q124002@Q000f]JOomoo`04Ool4@Q000e:DOomoo`0;Ool00g_N
1240000600001B48Oomoogoo12401`0000DDYGooOomoog>L00U24003Mke2448@00U24003DYAoodic
00=24003CW=oogoo009oo`03HaQ2448@009240Ioo`08Mke6<AcW36<@Q1cWAS5kgPEoo`08Nmi2448@
@Q0icS6<@Q1F]@]oo`07BU8HaPaS36<Lid8@Nmh02Goo000?Ool00cg_0000000500000eJeOomoo`1b
Ool00e:D0000000400000cF]Oomoo`02Ool00cg_0000000300000fmkOomoo`1gOol00b4800000005
00001B48Oomoogoo:DX01`0000<@Q7ooOol0GGoo000?Ool00g>L1240000500000f<HOomoo`1bOol0
0f<H0000000400000e[FOomoo`02Ool00dic0000000300000e[FOomoo`1gOol00d8@000000050000
1B48OomoogooDY@01`0000<8@WooOol0GGoo000@Ool00bU:0000000400000fmkOomoo`1bOol00g>L
0000000400000g_NOomoo`02Ool00ekg0000000300000dYBOomoo`1gOol00f<H0000000500001BU:
OomoogooNmh02000Ggoo000@Ool00e[F0000000400000g_NOomoo`1cOol00`@Q0000000200000aBU
Oomoo`03Ool00g>L0000000300000cW>Oomoo`1hOol00`@Q0000000400000c6<Oomoo`02Ool00b48
00000005001OOol0015oo`I247Ioo`03BU92448@00924003E[Eoogoo00Aoo`E24003F]Ioogoo07Qo
o`03CW=2448@00A24003F]Ioogoo009oo`03G_M2448@00E24003Nmioogoo05aoo`00ogooSGoo003o
Oon=Ool00?mooheoo`00ogooSGoo003oOon=Ool00?mooheoo`00ogooSGoo003oOon=Ool00?mooheo
o`00ogooSGoo003oOon=Ool00?mooheoo`00ogooSGoo001fOol00e[F@Q12402Q@Q000g>LOomoo`1_
Ool007Ioo`04HaQ>LdicDY@2CW<015:DCW=>Le:D0Tic00ABU4icCW=BU09>L`04DYA>LdicDY@2CW<0
15:DCW=>Le:D0Tic00ABU4icCW=BU09>L`04DYA>LdicDY@2CW<015:DCW=>Le:D0Tic00ABU4icCW=B
U09>L`04DYA>LdicDY@2CW<015:DCW=>Le:D0Tic00ABU4icCW=BU09>L`04DYA>LdicDY@2CW<015:D
CW=>Le:D0Tic00ABU4icCW=BU09>L`04DYA>LdicDY@2CW<015:DCW=>Le:D0Tic00ABU4icCW=BU09>
L`04DYA>LdicDY@2CW<015:DCW=>Le:D0Tic00ABU4icCW=BU09>L`04DYA>LdicDY@2CW<015:DCW=>
Le:D0Tic00ABU4icCW=BU09>L`04DYA>LdicDY@2CW<015:DCW=>Le:D0Tic00ABU4icCW=BU09>L`03
DYA>LgNm075oo`00ogooSGoo003oOon=Ool007Ioo`03Mkdmkd8@00924003?NmS67oo00=oo`03AS5o
ogoo009oo`03F]I2448@00A24006E[E:DT8@AS5BU6]J0goo00=Nmdic@Q000T8@00A:DVmkLia>L`A2
4003CW=[FWoo009oo`03F]I>Ld8@00924006AS5:DWooOomW>E:D148@00A>LfmkOom>L`Y24008CW=o
of<HCW=244HaCW=g_@=oo`07DYAoogooOomkgTicBU800d8@00M>Le[FBU9244HaCW=cW003Ool00e:D
CW=24002@Q0014YBMkeg_Dic148@00=>LfLiOol00goo00=>LdHa@Q000T8@00=:DU[FOol00Woo00mg
_Cg_8@Q6<EJeBU8icUkgOom[FTYB@Q16<DicKg/00goo00=F]Dic@Q000T8@00=:DWNmOol0LGoo001h
Ool00g_N5:E:DP06Ool00`aSF]Ioo`04Ool01GNm5:D001BUNmh00Woo00<U:F]JOol01Woo00<]J`00
<H`017oo00Ag_@Q2001BU0Moo`03AS4001S600Ioo`04Mkd<H`00G_L5Ool00acW001F]@05Ool00fmk
36=S6002Ool00acWHaQoo`04Ool00b48DYAoo`04Ool00bU:000e[@02Ool00g_N5:Eoo`07Ool00aBU
001:DP04Ool017Nm248005:D27oo00<Li`00=Jd017oo00AW>@Q2:DYkgP=oo`03IcT@Q124009oo`03
6<IkgWoo00Ioo`039BT0048@07Aoo`00NGoo0UJe1Goo00=kgP006<H01Woo00<mk`00;F/00goo00=[
FU[FOol01Woo00<U:@00IcT01Goo00<U:@00G_L01goo00=[FP006<H01goo00<YBP00G_L01Goo00<m
k`00F]H01Woo00I_NbU:OomooeJeHaP5Ool00`aS5:Eoo`04Ool00dic00124003Ool00e[FLiaoo`06
Ool00aBU001kgP05Ool00bDY001JeP08Ool00cg_00124003Ool017_N248DYG_N1Goo00Ig_ABUJeYo
oe[FKg/7Ool00b48001g_@1dOol007Uoo`03Nmi:DWoo00Aoo`04JeX00000DY@5Ool00dic000Li`04
Ool00dicOomoo`05Ool00a24249oo`05Ool00cW>001:DP08Ool00`0036=oo`06Ool00d8@001BU005
Ool00e:D0016<@07Ool01F<HKg]oogooBU8017oo00Ag_@00001F]@Aoo`03G_L003F]00Aoo`03CW=o
ogoo00Eoo`03124HaWoo00Eoo`03>Lh004YB00Qoo`03F]H002e[00=oo`03@Q0005:D00Moo`05LiaF
]GooOom>L`07Ool00`Q248Aoo`1dOol007Yoo`03BU9oogoo00=oo`04E[D000@Q@Q05Ool00ekg000<
H`04Ool00g>LHaQoo`04Ool00g_N000U:@06Ool00eJe000e[@08Ool00aBU001kgP06Ool00e[F0012
4005Ool00f<H000aS00;Ool00dicOomoo`02Ool01Ekg000Q25[FNmh00goo00=cW0008@P017oo00=N
mgNmOol017oo00=W>@00>Lh01Woo00=F]@00>Lh027oo00=_N`007>L00goo00<DY@00Nmh027oo00Ec
W7ooOomS67>L00Eoo`03JeX002U:07Eoo`00NWoo00=BU7ooOol00goo00E240008@Qg_E:D00Aoo`03
Kg/0000000Eoo`03BU9oogoo00=oo`03F]H0048@00Ioo`03IcT002U:00Qoo`039BT006Li00Ioo`03
Kg/003F]00Eoo`03Li`001cW00Aoo`03JeYoogoo00Aoo`03E[Eoogoo009oo`05BU8003W>Oom>L`04
Ool00`005:Eoo`04Ool00dicOomoo`03Ool00dYB001F]@06Ool00f]J000U:@09Ool00`0036=oo`02
Ool00`@Q001oo`0<Ool00dYBOomoo`03Ool00dic0012401eOol007Yoo`03HaQ_Ngoo00=oo`06<H`0
03W>Oom:DW_N0goo00AkgP00001g_@Aoo`03IcTmkd8@00=240039BT005[F00Ioo`03Nmh001BU00Qo
o`03>Lh005Je00Moo`03000U:Goo00Eoo`03000<Hgoo00=oo`03@Q1oogoo00Aoo`03NmiNmgoo009o
o`06;F/005:DOomNmg_N0goo00<<H`@QOol017oo00=F]D8@@Q000d8@00<HaP00Li`01Woo00=kgP00
5:D02Goo00<DY@00Nmh00Woo0P003Goo00=JeSg_@Q000d8@00<Li`00E[D0MGoo001kOol00dicOomo
o`02Ool01QcW001F]GooNmi:DPAoo`03124006]J00Eoo`03AS5cW7>L009cW0038@P007Nm00Moo`03
36<48Goo00Moo`03BU8004Ha00Moo`0336<HaWoo00Eoo`035:D007_N00=oo`03;F]oogoo00Eoo`07
E[EoogooOolDY@00JeX00Woo00IJeWooOomooaBU0006Ool00dHaLiacW002Li`00`aS249oo`07Ool0
0`Q2125oo`08Ool00bDY001W>@02Ool00`Q2001kgP0=Ool00cW>LiacW002Li`00a24001[FP1eOol0
07]oo`03CW=oogoo009oo`03248006]J009oo`03BU9kgWoo009oo`035:D005kg00Eoo`03F]Ioogoo
009oo`0348@<Hgoo00Moo`037>L007>L00Moo`03F]H0024800MBU0035:D8@Woo00Eoo`079BT004Ha
DYA:DS6<24801goo00IJeWooOomoo`@Q0003Ool01ekgOomoogoo9BT007>L00Eoo`07F]IoogooOomk
gP007>L027oo00<Li`00Li`027oo00<e[@00E[D00Woo00<Q2000HaP03Goo00=F]GooOol00Woo00<4
8@00Ool0MGoo001kOol01eJeMkeoogooLi`000@Q00Aoo`07E[EoogooOolU:@00E[D01Goo00MkgV<H
OomoogNm000Q2008Ool00c6<001JeP07Ool00g>L000DY@07Mkd00cF]001kgP05Ool023W>001BU7oo
NmiS61BUMkd6Ool01WNmIcUoof]J000Li`=oo`07NmiBU7ooOole[@00IcT01Goo00McW6]JOomooekg
000aS008Ool00cF]001JeP08Ool00dic00124002Ool00d8@0012400>Ool01V<HOomoofLi000HaWIo
o`00O7oo00IBU7ooOomJeP007>L4Ool01e:DOomoogoo<H`004Ha00Ioo`06E[EoogooG_L003W>27oo
00=:DP00BU8027oo00<48@Q2Ool01Woo00=:DP00HaP01Goo00=>L`00?Nl00goo00=F]EkgOol01Woo
00EF]GooE[D003F]00Aoo`06F]IkgWoo@Q0005[F1Woo00IJeWooOom:DP00BU88Ool00dHa001:DP08
Ool00ekg000]J`02Ool00gNm124@Q00>Ool01V<HOomoodYB000e[GIoo`00O7oo00I>LgooOolmk`00
>Lh4Ool01g_NCW=oogoo@Q0003g_00Ioo`06NmiS67oo@Q0004ic27oo00=JeP00=Jd027oo00<HaP00
Mkd01Woo00=Nm`00DY@01Goo00=Nm`00;F/017oo00=BU7ooOol01Goo00EJeWoo?Nl004YB00Eoo`05
E[Eooe:D001>L`06Ool2Kg/017oo;F/006<H27oo00=JeP00=Jd027oo00=g_@006<H00goo00<]J`00
HaP03Goo00IcW6mkOole[@00DYAfOol007aoo`06E[EkgWoo:DX004YB1Goo00I6<GooOom>L`00<H`7
Ool01E[FOol]J`00G_L027oo00=[FP008@P027oo00<YBP00IcT01Woo00=cW000?Nl01Goo00=g_@00
6<H037oo00EkgVLi;F/006<H00Eoo`05F]IkgUkg00124007Ool01E[FOolHaP00Li`027oo00=_N`00
8@P02Goo00<48@Q2Ool00Woo00=cW0@Q8@P027oo00=kgWooOol00goo00EJeWoo7>L006]J07Ioo`00
O7oo00IkgU[FOol8@P00HaP5Ool01WNmCW=ooeJe000YBPMoo`05NmiS61BU001kgP02Ool00g_NMkeo
o`04Ool00`0048Aoo`04Ool01W>LOomoocW>001>L`Moo`03000YBWoo00Eoo`030008@Woo00Ioo`03
Kg]oogoo00=oo`04F]HDY@00Nmh6Ool014icKg/003W>1goo00A_Nf]J0008@P=oo`03Nmig_Goo00Ao
o`03000@Q7oo00Aoo`07LiaoogooOolDY@00Mkd00goo00=:DP00F]H01goo00=JeVmkOol00goo00Ac
W6]J12448GMoo`00OGoo00EBU7>L000007_N00Ioo`05@Q1kgV]J000HaP08Ool00dYB0008@P04Ool0
0cF]Oomoo`03Ool00`aS001oo`04Ool01SW>OomoodYB000icPMoo`0336<DYGoo00Eoo`035:D007Nm
00Ioo`039BUoogoo00=oo`03CW<000aS00Moo`04DYA_N`00;F/8Ool00cg_000Li`04Ool00cF]Oomo
o`03Ool00a24001oo`04Ool01cW>Oomoogoo9BT005kg00Aoo`03;F/8@W>L00Ioo`03>LiS67oo00Ao
o`07?Nl001S6Oom:DSg_<H`0Lgoo001mOol015[FAS4000aS1goo00EkgT8@Mkd0012400Qoo`03Nmh<
HbDY00Aoo`03G_LQ27>L00=oo`038@P006mk00=oo`07DY@Q27ooOom>L`008@P01goo00<DY@00Mkd0
1Goo00<Li`00F]H01Goo0RDY1Goo00=>L`008@P027oo00=:DP007>L027oo00=_N`@Q?Nl017oo00=N
mb48Li`00goo00<Q2000Kg/00goo00=BU248Ool00Woo00<]J`00@Q001Goo00=6<AcWLi`017oo00=g
_@Q2DY@01Goo00Q_N`@Q=Jeood8@;F]246LiLWoo001nOol200000acWOomoo`06Ool014icKg/48@00
2Goo00=:DTHaOol017oo00<Lia24?Nl00T8@00<HaQ24;F/00T8@00H]J`Q2=JeS64Ha8@P248@00cF]
AS5g_@02Ool0548@?Nl@Q1249BU6<E:DOomF]Cg_5:D@Q248@Q1:DTic@Q0HaP00=Jd3Ool01Dic@Q0Q
20aS=Jd027oo00IJeP@Q48@mkdHaJeX6Ool00cW>E[Eoo`04Ool00acW48@mk`02@Q000aS648@]J`02
@Q002be[248aS7ooBU9241S648@DYD8@BU8017oo00U[FRU:>LiNmf]JE[D]JeJeIcT01Woo00HicU:D
Oom6<BDY;F]cOol007ioo`800003<Haoogoo00Moo`04>Lh@Q000Li`9Ool00gNmOomoo`03Ool00f]J
Oomoo`09Ool00f]JOomoo`0hOol00g_NOomoo`04Ool00f]JOomoo`09Ool00f]JOomoo`0=Ool2JeX0
0gNmOomoo`08Ool017_NOomoog>LM7oo001kOol00gNmLia6<@0200000cg_Oomoo`07Ool01THa1240
036<Kg]cW?aoo`00Ngoo00IF]DHaDYABU4icIcT9Ool00g_N@Q1BU002DY@00d8@Mkeoo`3jOol00?mo
oheoo`00ogooSGoo003oOon=Ool00?mooheoo`00ogooSGoo003oOon=Ool00?mooheoo`00ogooSGoo
003oOon=Ool00?mooheoo`00ogooSGoo0000\
\>"], "TitlePageLogo",
  Evaluatable->False,
  ImageSize->{396, 117},
  ImageMargins->{{322.063, 0}, {0, 131.313}},
  ImageRegion->{{0, 1}, {0, 1}},
  CellTags->"0.0"],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002M0000B1000`40O003h00OWGoo0002Ool01WNm
:DYoogoo<Ha_N`Qoo`058@Qoogoo<Ha_N`08Ool01B48Oomoocg_G_L01Woo0RU:1goo00DmkekgOomW
>Cg_00Moo`05CW<@Q00048A>L`06Ool00b48IcUoo`04Ool00cW>CW=oo`04Ool00fLi8@QW>@06Ool0
1WNm8@P000Q2>LhQ20Eoo`09CW<Q27ooOolQ26LiOolicTic00Eoo`03E[D006Li00Eoo`05MkdQ2000
001>L`05Ool01EJe48@000Q2AS401Woo00LQ26LiOolicTicOom>L`018@P0009oo`06?Nl006LiKg/0
036<1goo00I>L`00G_Mg_@Q2<H`7Ool01Ukg001>Lgoo248Q20Ioo`9F]@Ioo`07Mkd8@S6<OolaS0Q2
Mkd01Goo00MNm`00:DYNmbU:001Nm`05Ool00`00G_Moo`04Ool00b48?Nmoo`04Ool00ekg001Nm`06
Ool01S6<249F]EJe248000Eoo`09?Nl007ooOol005kgOolQ23g_00Eoo`03Kg/mkgNm00Eoo`056<H@
Q5JeCW=6<@04Ool01fmk000Q25kg<H`005Je00Eoo`07001Nmgoo8@Pmkgoo?Nl00@0000002GooMkd8
@PQ2<H`mk`00249g_@06Ool01124000Q24Ha0P0000=_NgooOol017oo00LQ20006<I>L`Q2001Nm`0=
Ool01cg_248006Li0008@Sg_00Eoo`03?Nl@Q7oo009oo`0348@aS7oo00Aoo`03001Nmgoo00Aoo`03
8@Pmkgoo00Aoo`03G_L005kg00Ioo`06248icWooOom>L`001Goo00Tmk`00Oomoo`00G_Moob48?Nl0
37oo00=W>@00E[D01goo00<mk`Q2Mkd00Woo00<HaRU:Ool017oo00L005kgOolQ23g_Oolmk`010000
0009Oolmk`00E[D000Q2AS48@Sg_00Eoo`08CW<005Je000@Q4Ha48@aS0Eoo`06G_L004ic0008@SW>
0R4837oo00Ug_@Q2?NlHaPQ248@mk`Q2Mkd017oo00<mkaS6Ool00Woo00<HaS6<Ool017oo00<005kg
Ool017oo00<Q23g_Ool017oo00=Nm`00G_L01Woo00H003g_OomooeJe0005Ool02Cg_001oogoo001N
mgoo8@Pmk`0<Ool00fLi001Nm`07Ool00cg_48Aoo`02Ool00bU:8@Qoo`04Ool01`00G_Moob48<Hao
ocg_0040000000Yg_@Q2<Haooa24249oocg_249g_@Aoo`0948@aS7oo8@P007NmCW<006mk00Aoo`8Q
2007OolYBP00Kg]>L`00G_L02goo00Tmk`00Kg]>L`00AS5g_@Q2?Nl017oo00MF]@00?Nm_NdHa001>
L`05Ool00`00G_Moo`03Ool017Nm6<HaS5kg17oo00ENm`00<HaW>GNm00Aoo`06:DX@Q6mkKg/HaP00
1Goo00Tmk`00G_MF]@00:DYg_A24?Nl03Goo00D@Q1S6Kg]NmeJe00Aoo`07G_L0036<Kg]6<@00AS40
1Goo00L002U:Mkd8@Q24MkdYBP0148@0000:CW<006mkOom>Lcg_Oomg_@Q2?Nl3Ool02Tic001Nmgoo
CW<aS7ooMkd8@S6<0goo00INm`00E[Eooekg:DX2Ool00a24:DYoo`0:Ool02PQ2<Haoogoo48Ag_Goo
<H`8@WNm17oo00DicP00000003W>00Ioo`03001Nmgoo00=oo`04G_L000000004Ool01Ekg0008@P00
?Nl017oo00IW>A24000002480005Ool02Cg_0008@P006<H@Q000249W>@0=Ool01FLi48@00000?Nl0
1Goo00E>L`00000003W>00Ioo`050008@P00248YBP020001?Nl000Aoo`9g_@aoo`03Mkeoogoo00Yo
o`03Kg]oogoo015oo`03Kg]oogoo00Qoo`03MkeNmgNm00Moo`03001Nmgoo00Aoo`038@Pmkgoo00Mo
o`03G_Mg_Goo00Eoo`03G_M_Ngoo00Qoo`06MkeNmgooOomNmgNm47oo0VLi1goo00=g_EkgKg/02Goo
00=NmgNmOol00VLi0Goo0018Ool00`00G_Moo`04Ool00b48?Nmoo`1;Ool004Qoo`03001Nmgoo00Ao
o`038@Pmkgoo04]oo`00B7oo00<005kgOol017oo00<YBQ24AS40Bgoo0018Ool00b48IcUoo`04Ool0
0fLi2480001;Ool009eoo`00WGoo002MOol009eoo`00WGoo002MOol009eoo`00WGoo002MOol009eo
o`00WGoo002MOol009eoo`00WGoo002MOol009eoo`00WGoo002MOol009eoo`00WGoo000=Ool00fmk
?Nm>L`04Ool00eJe?Nm6<@06Ool00fmk?Nlmk`06?Nl9Ool01Ukg<H`Q2248>Li_N`Uoo`Pmk`03Kg]o
ogoo00=oo`03G_Lmkdic00Uoo`03G_Lmkdic00Ioo`03CW<mkgoo00=oo`04IcTmkcg_Kg/:Ool00eJe
<H`Q20028@P00cW>IcUoo`07Ool00fmk?Nm>L`07Ool00dic?Nm_N`0<Ool000eoo`03G_L0024800=o
o`04Kg/8@P00AS46Ool00ekg000000060008Ool00c6<0000000400000dicOomoo`06Ool800000ekg
Oomoo`03Ool016mk000007Nm27oo00<@Q000CW<01Woo00<Q2000Ool00goo00<HaP00:DX02Goo00=N
ma2400001P0000<YBWooOol01Goo00=Nm`008@P01goo00<Q2000G_L037oo000=Ool00ekg000Q2003
Ool00b48000YBP07Ool00ekg000HaP06G_L7Ool01dic000004HaMke_NcW>00800003Kg]oogoo00Eo
o`8000INm`03Mkeoogoo00Aoo`038@P003g_00Moo`03G_L000Q200Moo`038@P007oo009oo`04?Nl0
00Q2Mkd8Ool02dic00000124CW=_NgooIcTmk`Q200001goo00=Nm`008@P01goo00<Q2000G_L037oo
000=Ool00ekg000Q2002Ool014Ha0008@WNm1goo00=Nm`008@P03Goo00<HaP00AS4017oo00<icP00
<H`01goo0P003Goo00=Nm`0048@01goo00<YBP00?Nl01goo00DQ2000OomoofLi00800003G_Moogoo
00Ioo`04G_L00000>Lh6Ool00gNm6<Ioo`06Ool00ekg000Q2007Ool00b48001Nm`0<Ool000eoo`05
G_L00248OomW>@0200000eJeOomoo`06Ool00ekg000Q200=Ool00cW>48Aoo`04Ool00fLi000Q2007
Ool2000>Ool00a24000mk`05G_L015Je000006mk1goo00LQ2000Oomg_AS6000icP09Ool00a24000a
S00@Ool00ekg000Q2007Ool00b48001Nm`0<Ool000eoo`07G_L00248OolHaP00>Lh02Goo00=Nm`00
8@P057oo00=Nm`008@P01goo0P003Woo00=>L`0000001`0000<aS7ooOol01Woo00HQ2000OolicP00
6<H9Ool015Je000@Q7Nm47oo00=Nm`008@P01goo00<Q2000G_L037oo000=Ool01ekg000Q23g_000H
aWNm00Uoo`03G_L0024801=oo`04MkdQ2000<H`7Ool2000?Ool00`Q2000HaP048@P200000ekgOomo
o`06Ool00b48001Nm`0200000fLiOomoo`07Ool00cW>000icP0AOol00ekg000Q2007Ool00b48001N
m`0<Ool000eoo`03G_L000Q200800003:DYF]Goo00Qoo`03G_L00248019oo`05CW<@Q000249W>@07
Ool2000?Ool00cg_000aS003Ool00dic000HaP09Ool01b480008@P006<I>LgNm00Qoo`038@P005kg
015oo`03G_L0024800Moo`038@P005kg00aoo`003Goo00=Nm`000000100000<aS7ooOol01Woo00=N
m`0000001P002Woo00Hmka2400000124IcT8Ool80009Ool016mk000007Nm0Woo00<Q2000CW<02Goo
00<Q200000000`0000<HaVmkOol01Woo00<Q2000G_L04Goo00=Nm`0000002@0000=NmgooOol02Woo
000=Ool02Ekg000Q27ooMke>L`Q2000mk`07Ool00ekg000000060008Ool01VLi6<H000006<I>L`Yo
o`P000Yoo`07<H`003g_OomW>@0024802Woo00PQ2000OomooeJe6<H002481goo00<YBP00CW<04Goo
00=Nm`0024801b4800<8@P00G_L037oo000=Ool00ekg000Q2003Ool00ekg000HaP07Ool00ekg000Q
200>Ool011S6000@Q5kg37oo0P0047oo00MW>@0048Aooc6<000icP0:Ool00b48001oo`02Ool017Nm
248007Nm1Woo00=6<@00:DX04Goo00=Nm`008@P01goo00<Q2000G_L037oo000=Ool00ekg000Q2004
Ool20007Ool00ekg000Q200=Ool016Li0008@WNm3Goo0P004Goo00HQ2000AS48@P00Kg/:Ool00b48
001oo`03Ool00b48001Nm`06Ool016mk000006Li47oo00=Nm`008@P01goo00<Q2000G_L037oo000=
Ool00ekg000Q2003Ool00fmk0008@P07Ool00ekg000Q200=Ool00ekg000Q2004Ool00gNmOomoo`07
Ool2000AOol01Dic0008@P00:DX02goo00<Q2000Ool00goo00<@Q000IcT01goo00@icP006<Ig_@Mo
o`03IcUoogoo00Eoo`03G_L0024800Moo`038@P005kg00aoo`003Goo00=Nm`008@P00Woo00Ag_B48
000YBPMoo`03G_L0024800eoo`04Mkd00000IcT3Ool28@P00fmkOomoo`05Ool2000BOol011240000
05kg2goo00<Q2000Ool00Woo00<icP00248027oo00Eg_AS6000@Q5kg00Eoo`03AS4007oo00Ioo`03
G_L0024800Moo`038@P005kg00aoo`003Goo00ENm`00248Q21S600800003249W>Goo00Ioo`03G_L0
00Q200HQ20Qoo`09>Lh000Q2<H`mka24000@Q7Nm00Moo`8000HQ2003IcUoogoo00Uoo`03AS400124
00aoo`058@P002488@P8@P0200000dicOomoo`07Ool02GNm8@P000006<HicSg_<H`8@P020007Ool0
0ekg000Q2007Ool00b48001Nm`0<Ool000eoo`03G_L0000000800003248aS6mk00Qoo`03G_L00000
00H000Uoo`03>Lh00000008000036<IW>Goo00Moo`P00003G_Moogoo00Uoo`03Mkd8@Tic00aoo`03
8@P0000000800003:DYNmgoo00]oo`03CW<@Q00000@000038@QNmgoo00Ioo`03G_L0024800Moo`03
8@P005kg00aoo`00<7oo00A_NekgG_MW>Amoo`03AS5g_Goo021oo`05IcUNmekgG_M_N`0ROol009eo
o`002Woo00=W>EkgG_L0Qekg2Goo000:Ool00dic?Nlmk`27?Nl9Ool009eoo`00WGoo000@Ool00ekg
0000000400000c6<Oomoo`02Ool00`Q2000000040008Ool00dic:DX8@P0400000b48AS5_N`05Ool0
0cW>8@PQ20098@P00gooCW<Q20058@P00fLiOomoo`03Ool00fLi8@PQ20048@P00fLiOomNm`0=8@P0
0cW>Oomoo`03Ool00bU:8@PQ20048@P00dHa8@PQ20038@P01BU:Oomoogoo>Lh00b4800AF]GooOomg
_@HQ2003IcUoogoo00Yoo`0047oo00=6<@000000100000D8@WooOomoofLi00L00003IcUoogoo00=o
o`03E[D@Q00000T00003?Nmoogoo009oo`038@P0000000T00003Oolmk`0000D00003G_Moogoo00=o
o`03G_L0000000@00003G_Moob4800H00003:DX8@P0000@00003249oogoo009oo`03Kg/0000000@0
00036<IF]@0000D0009oo`03Mkd0000000800004:DYoogooG_L600000fmkOomoo`0:Ool0011oo`03
>Lh0000000D00004IcUoogooAS4700000eJeOomoo`02Ool00dHa0000000;00001AS6Mkeoogoo8@P0
2`0000=oocg_00001@0000=NmgooOol00goo00=Nm`00000010000Ukg1P0000<8@WNm<H`01P001248
00<HaP000000100000=>LfLi00001@000Woo00=>L`0000000`0000=g_GooG_L01P003Goo000@Ool0
0b4800000005000013g_OomoobU:1`0000DmkgooOomoodic00l00004:DYoogoo8@P;00000goo?Nl0
000500000ekgOomoo`03Ool00ekg0000000400000ekg8@P0000500000eJeOomNm`0A00000gNmOol0
000500000ekgOolaS00500000dicOomF]@0500000b48Oomoo`0;Ool0011oo`032480000000D00003
6<Ioogoo00P00005:DYoogooMkd8@P0@00000eJeOolQ200;00000goo?Nl0000500000ekgOomoo`03
Ool00ekg0000000400000cg_0000000400001BU:Oomoogoo48@03`0000@YBWooOolHaPD00003G_Mo
o`Q200D00003:DYoocg_00D00003<Haoogoo00]oo`003goo00=g_@0000001`0000=g_Ekg00001`00
00@HaWooOom6<@L0000348@Q21S600L000036<Ioob4800/00003Oolmk`0000D00003G_Moogoo00=o
o`03G_L0000000@000032480000000<00003249g_Goo009oo`03>Lh0000000d00004CW=oogoo:DX5
00000dicE[D0000600000gNm?Nl0000400000cg_Oomoo`0;Ool000moo`03G_L0000000L00003CW<m
k`0000P0009oo`036<H0000000@00005<HaoogooOomNm`0700000fmk8@P0000400000b48Oomoo`04
Ool00cg_0000000400001aS68@PQ2248>Liooekg00`00003E[Eoogoo009oo`03IcT0000000@00003
6<HQ212400D00005249oogooOolmk`0500000cg_>Lh0000600000eJe<H`0000400000ekgOomoo`0;
Ool000moo`03AS40000000L00003<H`Q200000P00003IcUoo`0000D0000348Aoogoo00=oo`03>Lh0
000000@00003G_LQ200000@000038@Qoogoo00Aoo`03?Nl0000000P000038@Qooekg00/00003248a
S7Nm00Aoo`0348@0000000<00003?NmoobU:00D00005<HaoogooOom>L`0500000cg_48@000060000
0c6<8@P0000400000fmkOomoo`0;Ool000moo`03>Lh0000000<0000548@00000000HaP0:00000ekg
Ool0000500000cg_Oomoo`03Ool00ekg0000000400000dic8@P0000400000b48Oomoo`04Ool00cg_
0000000800000b48OomNm`0=00000`Q2Kg]oo`02Ool00cW>0000000300000bU:Ool8@P0500001EJe
OomoogooG_L01@0000<@Q00000001P0000<8@R48000010003Woo000?Ool00b480000000300000bU:
0000000600000aS60000000300000cg_Ool0000500000c6<Oomoo`03Ool00eJe0000000400000dic
8@P0000400000b48Oomoo`04Ool00cg_0000000800000b48OomNm`0>00001C6<OomoogooIcT01@00
00<8@VLi0000100000<8@WooOol00goo2P0000<Q200000000P0000<8@P0000000P0000<Q27ooOol0
37oo000?Ool00`Q20000000300000dic0000000600000dic0000000300000c6<Ool0000500000`Q2
Mkeoo`03Ool00bU:0000000400000ekg8@P0000400000b48Oomoo`04Ool00cg_0000000800000b48
OomNm`0600000dHaE[D@Q00500000aS6Oomoo`02Ool00aS60000000300000cW>0000000300000cW>
Oomoo`03Ool00a240000000700000eJe0000000700000c6<Oomoo`0<Ool000ioo`03Mkd0000000<0
000348Ag_@0000H000036<INm`0000@000038@Qoob4800H000056<I_NgooOolmk`0700000gNm8@P0
000400000b48Oomoo`04Ool00cg_0000000400000ekgOomoo`03Ool00ekg0000000400000ekgOolm
k`060004Ool00dHa0000000300000aS60000000300000fLiOomoo`03Ool00b480000000600000bU:
Mkd0000800000cg_Oomoo`0<Ool000ioo`03G_L0000000<000038@QoobU:00H00003AS5_N`0000D0
0003Oom6<@0000L0000348@0000000H000038@Qoob4800D000038@Qoogoo00Aoo`03?Nl0000000@0
0003<H`mkcg_008mk`9Nm`H00003AS5F]A2400D00003249oogoo009oo`03Kg/0000000P0000348Ao
ogoo00Aoo`03?Nl0000000H00003AS5ooaS600P00003G_Moogoo00aoo`003Woo00=6<@0000000`00
00<Q27ooCW<01P0000=W>Goo00001@0000=_NgNm2480400000=Nmgoo8@P01@0000<Q27ooOol017oo
00<mk`0000002@0000<mkekg00003@0000<YBWooOol00goo00<HaP0000001`0000<mkgooOol017oo
00=>L`0000001P0000=W>Goo?Nl0200000=W>GooOol037oo000>Ool00cg_0000000300000cW>Oomg
_@0500000a24Oomoo`0600000ekgOomF]@0?0000136<Oomoob481@0000<Q27ooOol017oo00<mk`00
00002@0000<mkekg00003@0000=>LgooOol00goo00=6<@0000001`0000=_NgooOol017oo00=Nm`00
00001@0000@8@WooOomW>@P000moo`003Woo00<Q200000000`0000@mkgooOolYBP@00004>Lioogoo
8@P5000013g_Oomoodic3@0000DaS7ooOomoob4800D000038@Qoogoo00Aoo`03?Nl0000000T00003
?NmNm`0000`000038@Qoogoo00Aoo`03Kg/0000000H000036<Ioogoo00Eoo`03Mkd0000000D00005
:DYoogooOol8@P0600000aS6Oomoo`0=Ool000ioo`0348@0000000<00004?NmoogooAS44000015kg
Oomoob481@0000HicWooOomooekg48@900000`Q2?Nmoo`03Ool00b480000000300000b48Oomoo`04
Ool00cg_0000000900000cg_G_L0000;00000bU:Mkeoo`06Ool00bU:0000000500000dHaOomoo`06
Ool00`Q20000000400001DHaOomoogoo<H`01P0000<YBWooOol03Goo000>Ool68@P016LiOomoofmk
12480goo00<mkb488@P00b4800<icWooOol00goo00=>LbU:2480100000<HaTHaMkd01Goo00<icR48
8@P00b4800<icWooOol017oo00=>Lb488@P02B4800=>LfLi8@P02B4800<mkfLiOol027oo00=F]B48
8@P01B4800=g_GooOol01Woo00<icR488@P0124800E_NgooOomooeJe00HQ2003CW=oogoo00eoo`00
\
\>"], "TitlePageLogo",
  Evaluatable->False,
  ImageSize->{156, 73},
  ImageMargins->{{455.813, 0}, {0, 143.5}},
  ImageRegion->{{0, 1}, {0, 1}},
  CellTags->"0.0"]
}, Open  ]],

Cell[TextData[Cell[BoxData[GridBox[{
        {
          ButtonBox[
            StyleBox["\[FirstPage]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageFirst"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"First Slide"], 
          ButtonBox[
            StyleBox["\[LeftPointer]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPagePrevious"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Previous Slide"], 
          ButtonBox[
            StyleBox["\[RightPointer]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageNext"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Next Slide"], 
          ButtonBox[
            StyleBox["\[LastPage]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageLast"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Last Slide"], " ", 
          ButtonBox[
            StyleBox[
              RowBox[{
                CounterBox["SlideShowNavigationBar"], \(\(\ \)\(of\)\(\ \)\), 
                
                
                CounterBox["SlideShowNavigationBar", {None, 
                  "SlideShowHeader", -1}]}],
              "SR"],
            ButtonFrame->"None"]}
        }]]]], "SlideShowNavigationBar",
  CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell["Advanced Numerical Methods", "Section"],

Cell["\<\

\
\>", "Text",
  FontSize->16],

Cell[TextData[{
  StyleBox[" sada program\:016f roz\[SHacek]i\:0159uj\[IAcute] CSP 2.0 o \
pokro\[CHacek]il\[EAcute] numerick\[EAcute] metody",
    FontSize->18,
    FontWeight->"Bold"],
  StyleBox["\n\t\n\t",
    FontSize->18,
    FontSlant->"Italic"]
}], "Text",
  CellDingbat->"\[FilledSmallCircle]",
  FontSize->16],

Cell[TextData[StyleBox[" pou\:017eit\[IAcute] p\:0159i anal\[YAcute]ze a n\
\[AAcute]vrhu line\[AAcute]rn\[IAcute]ch \
\:0159\[IAcute]d\[IAcute]c\[IAcute]ch syst\[EAcute]m\:016f\n\n",
  FontSize->18,
  FontWeight->"Bold"]], "Text",
  CellDingbat->"\[FilledSmallCircle]",
  FontSize->16],

Cell[TextData[{
  StyleBox[" nov\[EAcute] volby v\[YAcute]po\[CHacek]t\:016f (",
    FontSize->18,
    FontWeight->"Bold"],
  StyleBox["Options",
    FontSize->18,
    FontWeight->"Bold",
    FontSlant->"Italic"],
  StyleBox[") pro standardn\[IAcute] fukce v CSP",
    FontSize->18,
    FontWeight->"Bold"],
  StyleBox["\n\t\n\t",
    FontSize->18,
    FontSlant->"Italic"]
}], "Text",
  CellDingbat->"\[FilledSmallCircle]",
  FontSize->16],

Cell[TextData[{
  StyleBox[" nov\[EAcute] numerick\[EAcute] funkce",
    FontSize->18,
    FontWeight->"Bold"],
  StyleBox["\n\t\n\t",
    FontSize->18,
    FontSlant->"Italic"]
}], "Text",
  CellDingbat->"\[FilledSmallCircle]",
  FontSize->16]
}, Open  ]],

Cell[TextData[Cell[BoxData[GridBox[{
        {
          ButtonBox[
            StyleBox["\[FirstPage]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageFirst"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"First Slide"], 
          ButtonBox[
            StyleBox["\[LeftPointer]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPagePrevious"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Previous Slide"], 
          ButtonBox[
            StyleBox["\[RightPointer]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageNext"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Next Slide"], 
          ButtonBox[
            StyleBox["\[LastPage]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageLast"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Last Slide"], " ", 
          ButtonBox[
            StyleBox[
              RowBox[{
                CounterBox["SlideShowNavigationBar"], \(\(\ \)\(of\)\(\ \)\), 
                
                
                CounterBox["SlideShowNavigationBar", {None, 
                  "SlideShowHeader", -1}]}],
              "SR"],
            ButtonFrame->"None"]}
        }]]]], "SlideShowNavigationBar",
  CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell["Advanced Numerical Methods", "Section",
  CellTags->"LastSlide"],

Cell["\<\

\
\>", "Text",
  FontSize->16],

Cell[TextData[{
  StyleBox[" \:0159e\[SHacek]en\[IAcute] Lyapunovy rovnice",
    FontSize->18,
    FontWeight->"Bold"],
  StyleBox["\n\t\t\n\t\t",
    FontSize->18,
    FontSlant->"Italic"]
}], "Text",
  CellDingbat->"\[FilledSmallCircle]",
  FontSize->16],

Cell[TextData[StyleBox[" \:0159e\[SHacek]en\[IAcute] algebraick\[EAcute] \
Riccatiho rovnice\n\n",
  FontSize->18,
  FontWeight->"Bold"]], "Text",
  CellDingbat->"\[FilledSmallCircle]",
  FontSize->16],

Cell[TextData[{
  StyleBox[" konstrukce a testy pozorovateln\[EAcute] a \
\:0159iditeln\[EAcute] formy",
    FontSize->18,
    FontWeight->"Bold"],
  StyleBox["\n\t\n\t",
    FontSize->18,
    FontSlant->"Italic"]
}], "Text",
  CellDingbat->"\[FilledSmallCircle]",
  FontSize->16],

Cell[TextData[{
  StyleBox[" zp\:011btnovazebn\[IAcute] stabilizace",
    FontSize->18,
    FontWeight->"Bold"],
  StyleBox["\n\t\n\t",
    FontSize->18,
    FontSlant->"Italic"]
}], "Text",
  CellDingbat->"\[FilledSmallCircle]",
  FontSize->16]
}, Open  ]]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 1280}, {0, 951}},
ScreenStyleEnvironment->"SlideShow",
WindowToolbars->"EditBar",
WindowSize->{1272, 924},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
Magnification->1.5,
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "SlideShowHeader"->{
    Cell[1754, 51, 1717, 45, 20, "SlideShowNavigationBar",
      CellTags->"SlideShowHeader"],
    Cell[51593, 710, 1717, 45, 20, "SlideShowNavigationBar",
      CellTags->"SlideShowHeader"],
    Cell[54740, 817, 1717, 45, 20, "SlideShowNavigationBar",
      CellTags->"SlideShowHeader"]},
  "0.0"->{
    Cell[3591, 104, 36931, 460, 373, 36786, 455, "GraphicsData", 
    "Bitmap", "TitlePageLogo",
      Evaluatable->False,
      CellTags->"0.0"],
    Cell[40525, 566, 11053, 141, 325, 10911, 136, "GraphicsData", 
    "Bitmap", "TitlePageLogo",
      Evaluatable->False,
      CellTags->"0.0"]},
  "LastSlide"->{
    Cell[56482, 866, 70, 1, 76, "Section",
      CellTags->"LastSlide"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"SlideShowHeader", 58328, 936},
  {"0.0", 58629, 943},
  {"LastSlide", 58942, 952}
  }
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 1717, 45, 20, "SlideShowNavigationBar",
  CellTags->"SlideShowHeader"],

Cell[CellGroupData[{
Cell[3496, 100, 92, 2, 76, "Section"],
Cell[3591, 104, 36931, 460, 373, 36786, 455, "GraphicsData", "Bitmap", \
"TitlePageLogo",
  Evaluatable->False,
  CellTags->"0.0"],
Cell[40525, 566, 11053, 141, 325, 10911, 136, "GraphicsData", "Bitmap", \
"TitlePageLogo",
  Evaluatable->False,
  CellTags->"0.0"]
}, Open  ]],
Cell[51593, 710, 1717, 45, 20, "SlideShowNavigationBar",
  CellTags->"SlideShowHeader"],

Cell[CellGroupData[{
Cell[53335, 759, 45, 0, 76, "Section"],
Cell[53383, 761, 41, 4, 78, "Text"],
Cell[53427, 767, 319, 10, 127, "Text"],
Cell[53749, 779, 286, 6, 127, "Text"],
Cell[54038, 787, 440, 16, 127, "Text"],
Cell[54481, 805, 244, 9, 127, "Text"]
}, Open  ]],
Cell[54740, 817, 1717, 45, 20, "SlideShowNavigationBar",
  CellTags->"SlideShowHeader"],

Cell[CellGroupData[{
Cell[56482, 866, 70, 1, 76, "Section",
  CellTags->"LastSlide"],
Cell[56555, 869, 41, 4, 78, "Text"],
Cell[56599, 875, 256, 9, 127, "Text"],
Cell[56858, 886, 201, 5, 127, "Text"],
Cell[57062, 893, 280, 10, 127, "Text"],
Cell[57345, 905, 245, 9, 127, "Text"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

